Getting started

SQL Data Compare enables you to compare and synchronize the data in two Microsoft® SQL Server™ databases. You can also compare a backup with a database, a scripts folder, or another backup. SQL Data Compare enables you to synchronize multiple tables whilst maintaining referential integrity.

This is useful, for example, to identify the differences between the contents of two databases following a failed replication; or to restore selected rows from a backup.

You can use SQL Data Compare to compare and synchronize data in SQL Server 2008, SQL Server 2005, and SQL Server 2000 databases.

SQL Data Compare: step-by-step

  1. Select a databases or database objects to compare
  2. View the differences between objects
  3. Synchronize your databases or create a synchronization script

Worked examples

Learn more about SQL Data Compare by following one of these detailed examples:

  • Synchronizing data in two databases
  • Performing table-level and row-level restores from a backup
  • Deploying a database from source control

Technical notes

SQL Data Compare's mapping features allow you to compare any tables with compatible data types.

For more information, see Which data types can be compared

You can create a rollback script to undo data synchronization

You can filter the comparison using a WHERE clause

SQL Data Compare can take time to compare and synchronize data sources. Speed depends primarily upon disk write speed, processor speed, memory, and the size of the databases. However, there are a number of ways to improve the performance of SQL Data Compare.

If your tables or views are very different, for example if data types are different, Red Gate Software offers SQL Compare ®, which will synchronize the structure of two databases. You can then use SQL Data Compare to synchronize the data.

Getting more information

  • What's new in this version?
  • Find out about activating SQL Data Compare.
  • How can I check for updates to SQL Data Compare?
  • Find out more about Red Gate.

© Red Gate Software Ltd. All Rights Reserved.


Using SQL Data Compare

In this chapter

  • Worked example: synchronizing data in two databases
  • Worked example: restoring from a backup file
  • Keeping a database in source control
  • Synchronizing views
  • Comparing databases on different SQL Server versions
  • Creating a rollback script


Worked example: synchronizing data in two databases

This worked example demonstrates a basic comparison and synchronization of two SQL Server databases.

In the example, the Magic Widget Company has a SQL Server database running on a live web server. This database contains a number of tables, views, stored procedures, and other database objects. The Magic Widget Company's development team has been working on an upgrade to their website. As part of this upgrade, they have made a number of changes to the database, which need to be transferred to the production database.

You can follow the example on your own system. You will need access to a SQL Server to do this.

This example has three steps:

  1. Set up the comparison

    Create the example databases, and specify the data sources, tables, and views you want to compare.

  2. Select data to synchronize

    Review the results and select the rows you want to synchronize.

  3. Synchronize the databases

    Create and run a synchronization script.

The worked example uses the following sample databases:

  • WidgetDev is the development database
  • WidgetLive is the production database

Set up the comparison

In this example, there are three steps to setting up the comparison:

  1. Create and specify data sources
  2. Select tables and views
  3. Set object mappings

It is not always necessary to set object mappings. However, in this example there are some schema differences between the source and target.

For more information, see Mapping objects

Create and specify data sources

  1. To create the databases, paste the SQL creation script into your SQL editor, then run it.

    The databases are created and populated with data.

  2. Start SQL Data Compare if it is not already running.

    The Project Configuration dialog box is displayed showing your most recent project:

    You can edit the current project, or create a new project.

    If you want to create a new project, click Cancel to close the dialog box, and on the toolbar click [image] (New Project)

    If you have any existing projects, and the Projects dialog box is displayed instead, click New Project.

  3. In the shaded upper pane, ensure the Source and Target are set to Database.

    In this example, we will compare databases. You can also compare backups and scripts folders.

  4. For each data source, in the Server box, type or select the name of the server on which you set up the databases.
  5. For the source, in the Database box, type or select WidgetDev.

    For the target, type or select WidgetLive.

    If the databases are not displayed in the Database lists, right-click in each Database box and click Refresh, or scroll to the top of the list and click Refresh.

Select tables and views

  1. To specify the tables and views you want to include, click the Tables & Views tab:

    The Tables & Views tab enables you to specify:

    • the tables and views you want to compare
    • which specific columns you want to compare
    • the comparison key SQL Data Compare uses to match rows in the two databases

      Note that by default SQL Data Compare does not compare views.

  2. To include views, on the Options tab, select the check box for Include views:

    The Options tab allows you to modify the behavior of SQL Data Compare during comparison and synchronization.

  3. Click the Tables & Views tab again.

    The WidgetPriceList view is now included in the comparison.

    Note that for the WidgetPrices table, only 4 out of the 6 columns will be compared, as two of the column names do not match. To include the remaining columns, you must map the objects.

Set object mappings

  1. To include the remaining columns, click the Object Mapping tab:

    The Object Mapping tab displays a list of table and view mappings.

    Mappings define which tables and views can be compared. For example, the table WidgetDescriptions in WidgetDev is mapped to WidgetDescriptions in WidgetLive. However, it can be mapped to any table with a sufficiently similar structure.

    You can use the object mappings to compare tables with different or similar names.

    The table WidgetPrices shows a Partial mapping, as not all of its columns could be automatically mapped.

  2. To view and edit the column mappings, click Partial for the WidgetPrices table:

    A dialog box is displayed for you to edit the column mappings.

  3. In the lower pane of the dialog box, click DateValidFrom and then ValidFrom, and then click [image] Map to map the columns.

    The columns move to the upper pane of the dialog box.

  4. Map the DateValidTo and ValidTo columns in the same way, and click Close.

    The status for the WidgetPrices table changes to Mapped.

  5. Click Compare Now.

SQL Data Compare displays a message dialog box that shows the progress of the comparison. If you select the Close dialog box on completion check box, SQL Data Compare closes this message dialog box automatically the next time that you run a comparison on a project. For this example, leave the setting as it is, and click OK to close the message box.

Select data to synchronize

The comparison results are displayed in the main window.

In this example, the comparison results are grouped by:

tables or views with differences in their rows

tables or views with identical rows only

To display the comparison results in a single list, in the Group by box, select No groups.

To display the comparison results in groups, select Type of difference.

To view the comparison results for each object group, click [image] or click the grouping bar:

The upper (Results) pane also shows how many rows of each type exist for each table or view. For example, the table WidgetPrices contains:

  • three rows that exist in WidgetDev but not in WidgetLive
  • one row that exists in both databases but has different values
  • no rows that exist in WidgetLive but not in WidgetDev.

The Identical column shows that there are two rows that are identical.

Finding objects

To locate objects, type the search text in the Find box. To select a recent search, click the Find arrow button

As you type, objects are grouped in the upper pane by whether they match or do not match what you type:

Note that the search is not case-sensitive.

To clear the Find box click the [image] button.

Viewing row differences

To view detailed information about the data in a table or view, click on it in the upper pane. The lower (Row Differences) pane is displayed.

Click the table WidgetDescriptions to see the row differences:

In this example WidgetID is the comparison key [image] , used by SQL Data Compare to match rows in the two databases.

For the row where WidgetId is 2, the values for Short Description and Description are the same in both databases, so the data is displayed in gray text.

The Picture values are different so they are displayed with the darker shaded background.

To view a specific value in a row double-click it, or right-click and select Show Viewer. Binary Data values are displayed as links. Click the Binary Data link for the row where WidgetId is 2.

For tables or views that contain a large number of columns, you may find it useful to display the column values vertically so that you can see records more easily. To do this, click Show, then Pivot View

To display the column values horizontally again, click Show, then Pivot View

You can move through each difference in turn using the [image] and [image] buttons. To move through the differences for the current column, click [image] or

Selecting rows to synchronize

Use the check boxes in each pane to select data for synchronization. You can select individual tables or views to synchronize, and for each table or view you can select the rows that you want to synchronize. By default, all rows that differ are selected when you run a comparison.

For this example, select all the tables and their rows. Ensure that the check boxes are cleared for the WidgetPriceList view. You do this by clearing the Different check box for WidgetPriceList:

The number of rows selected for synchronization is shown in the Direction Bar.

To synchronize, Click [image] Synchronization Wizard.

Synchronize the databases

On the first page of the Synchronization Wizard you can choose to create and save a synchronization script, or perform the synchronization using SQL Data Compare.

Choose synchronization method

In this example, we will synchronize using SQL Data Compare.

  1. Ensure that Synchronize using SQL Data Compare is selected.
  2. Clear the Back up target before synchronization check box if it is selected.

    In this example, we will not back up before synchronization.

    For more information, see Backing up before synchronization

  3. To generate the synchronization script, click Next

    The Review page is displayed.

Review the synchronization script

There are three tabs on the Review page:

  • Synchronization script shows the script to synchronize the data sources.

    You can search the script, save it, or copy it to the clipboard.

  • Summary shows a synopsis of the actions in the synchronization script.

    You can view the summary grouped by the objects affected, by the type of modification, or by the order in which the script modifies the target.

  • Warnings shows a list of any warnings about unexpected behavior that may occur when you synchronize the databases.

For more information, see Warnings

Perform the synchronization

When you have reviewed the script, synchronize the databases:

  1. Click Synchronize Now to perform the synchronization.
  2. A confirmation dialog box is displayed. Click Synchronize Now to continue.
  3. SQL Data Compare displays a message dialog box that shows the progress of the synchronization.

    When the synchronization is complete, click OK to close the message box.

SQL Data Compare then re-compares the databases. The results are shown in the main window. In this example, all tables and their rows are shown to be identical, confirming that the synchronization has been a success.

Note that the WidgetPriceList views are also now identical, because the tables that they reference have been synchronized:

See also

Mapping objects

Selecting tables and views

Setting data sources

Setting project options

Setting up the synchronization

Viewing the comparison results

Viewing the row differences

Worked example: restoring from a backup file

Working with projects


Worked example: restoring from a backup file

This worked example demonstrates a table-level restore from a backup file. You can also restore specific rows.

In the example, the Magic Widget Company has a SQL Server database running on a test web server. The Magic Widget Company's test team has been testing the new version of the web site.

One of the software testers has updated the Contacts table, intending to update one email address. They did not specify a WHERE clause, and consequently have updated the entire table. During the day some other rows in the Contacts table have been modified. The database administrator has been asked to restore the data from a backup and apply some but not all of the changes that were made to the test server.

You can follow the example on your own system, if you are using the SQL Data Compare Professional edition. You will need access to a SQL Server to do this.

If you have not already followed the Comparing and synchronizing two databases worked example, you are recommended to do so before starting this worked example.

This example has three steps:

  1. Set up the comparison

    Create the example databases, and specify the data sources you want to compare.

  2. Select rows to restore

    Review the results and select the rows you want to restore.

  3. Synchronize the data sources

    Create and run a synchronization script.

The worked example uses the following data sources:

  • WidgetTest is the test database
  • WidgetLive is the database used to create the backup
  • BeforeEmailUpdate.bak is the backup file

Set up the comparison

To improve performance, and make the comparison results easier to interpret, in this example we will compare only a single column in a single table. To do this, we will specify the data sources, then the table, then the column. No other values are included in the comparison.

Specify data sources

  1. To create the databases, paste the SQL creation script into your SQL editor, then run it.

    The databases are created and populated with data.

  2. To create the backup file, run the command:

    BACKUP DATABASE WidgetLive
    TO DISK = 'c:\BeforeEmailUpdate.bak'
    WITH INIT,
    NAME='BeforeEmailUpdate'

    The backup is created at the root of the C drive on the computer running the instance of SQL Server you are connected to.

  3. Start SQL Data Compare if it is not already running. The Project Configuration dialog box is displayed showing your most recent project. You can edit the current project, or create a new project.

    If you want to create a new project, click Cancel to close the dialog box, and on the toolbar click [image] (New Project)

    If you have any existing projects, and the Projects dialog box is displayed instead, click New Project.

  4. On the Project Configuration dialog box, under Source, select Backup:

  5. Click Add Backup Set Files to specify the backup.

    The Add Backup set Files dialog box is displayed.

  6. Select the file BeforeEmailUpdate.bak, and click Open.

    The BeforeEmailUpdate backup set is displayed in the list of backup sets.

  7. Under Target, select Database.
  8. In the Server box, type or select the name of the SQL Server where you created the sample databases.
  9. Type or select WidgetTest in the Database box.

    If the database is not displayed in the Database list, right-click the Database box and click Refresh, or scroll to the top of the list and click Refresh.

  10. On the Options tab, click Red Gate Defaults, to ensure the default options are being used.
  11. Click the Tables & Views tab.

    The Tables & Views tab enables you to select the tables you want to compare and which columns you want to compare.

    By selecting only the tables that you want to compare, you will improve the performance of SQL Data Compare, as it does not need to read the entire backup file. This is useful for large backup files.

    Note that if you are using a backup as a data source, you cannot compare views.

  12. Click [image] None, then select the check box for the Contacts table.

    Only Contacts is included in the comparison.

  13. Click in the Columns in Comparison box for the Contacts table, and on the dialog box, clear the check boxes for all columns except Email, then click Close.

    Alternatively, you can right click, click Select None, then select the check box for the Email column.

    Only 2 out of the 9 columns in the Contacts table will be compared; the ID column (the comparison key) and the Email column.

  14. Click Compare Now.

SQL Data Compare displays a message dialog box that shows the progress of the comparison. If you select the Close dialog box on completion check box, SQL Data Compare closes this message dialog box automatically the next time that you run a comparison on a project. For this example, leave the setting as it is, and click OK to close the message box.

Select rows to restore

The results of the comparison are displayed in the upper (Results) pane:

To view the comparison results, click [image] or click the object group bar:

The upper pane also shows how many rows of each type exist. There are 2 rows that exist in the backup but not in the WidgetTest database, 98 rows that exist in both the backup and the WidgetTest database but have different values, and 2 rows that exist in the WidgetTest database but not in the backup.

In the upper pane, click Contacts to display detailed information about the rows:

ID is the comparison key [image] . Email values that are different are displayed with a dark shaded background; Email values that do not exist in one data source but do exist in the other are displayed with a shaded, patterned background.

If you scroll through the rows, you can see that all the Email values have been set to Matt.Mitchell@example.com except for the two rows that do not exist in the WidgetTest database and the two rows that do not exist in the backup.

As restoring all rows would over-write those that exist only in the target, we must exclude these rows from the synchronization.

In the upper pane, clear the Target Only check box:

100 of 102 rows are now selected for synchronization.

To restore specific rows, you can use the Include check boxes in the lower (Row Differences) pane to select the rows you want to synchronize. Alternatively, you can filter the comparison with a WHERE clause.

In this example, we will synchronize the remaining 100 rows.

Click [image] to run the Synchronization Wizard.

4. Synchronize the databases

On the first page of the Synchronization Wizard you can choose to create and save a synchronization script, or perform the synchronization using SQL Data Compare. In this example, we will synchronize using SQL Data Compare, and perform a backup before synchronization.

Choose synchronization method

  1. Ensure that Synchronize using SQL Data Compare is selected.
  2. Ensure that Back up target before synchronization is selected.
  3. Ensure that Save a copy of the synchronization script is selected.
  4. Click Next

Configure backup

  1. In the Backup using check box, select Native SQL Server

    If you have installed SQL Backup on the SQL Server, you can select Red Gate SQL Backup instead.

    For more information, see Backing up before synchronization

  2. In the Backup folder box, specify the backup location, and in the box on the right hand side, type a file name, for example WidgetTestBackup
  3. Click Next

Review

There are three tabs on the Review page:

  • Synchronization script shows the script to synchronize the data sources.

    You can search the script, save it, or copy it to the clipboard.

  • Summary shows a synopsis of the actions in the synchronization script.

    You can view the summary grouped by the objects affected, by the type of modification, or by the order in which the script modifies the target.

  • Warnings shows a list of any warnings about unexpected behavior that may occur when you synchronize the databases.

For more information, see Warnings

You can choose to run the SQL script from within SQL Data Compare, launch your SQL editor so that you can modify the script, or save the SQL script without synchronizing the databases.

In this example, we will choose to run the script, then compare the databases again to check the results, and save a copy of the synchronization SQL script (the default)

  1. Click Synchronize Now to run the synchronization.
  2. A confirmation dialog box is displayed. Click Synchronize Now to continue.

    The backup is created, the synchronization is performed, then the data sources are compared.

    For this example, leave the setting as it is, and click OK to close the message box.

    The comparison results show that the Email values for rows that existed in both the backup and the WidgetTest database have been synchronized:

See also

Setting data sources

Setting project options

Setting up the synchronization

Viewing the comparison results

Worked example: synchronizing data in two databases

Working with projects


Keeping a database in source control

You can use the scripts folder functionality of SQL Data Compare and SQL Compare to keep your database under source control during development.

The diagram below provides an overview of the process, with tooltips and links to more detailed information:

The interactive parts of this graphic could not be displayed.

The process has three stages:

  1. Set up source control

    SQL Compare and SQL Data Compare are used to create a scripts folder you can check into your source control repository.

    To learn more about comparing and synchronizing scripts folders, see Worked example: using a scripts folder as a data source

  2. Modify the database

    Periodically, changes to the development database are compared and synchronized with the scripts in source control, maintaining a stable latest version.

  3. Deploy the database

    The final version of the scripts in source control are deployed to a target database, using SQL Compare then SQL Data Compare.

For more information, see Continuous integration for databases using Red Gate SQL tools (pdf)

Note that scripts folders are only available if you are using the SQL Compare or SQL Data Compare Professional Edition.

See also

Deploying a database from source control

Worked example: synchronizing data in two databases

Working with scripts folders

Using the Synchronization wizard

Getting started with the SQL Data Compare command line


Synchronizing views

SQL Data Compare can synchronize views directly only if they reference rows from a single table, and the referenced columns are simple (for example, they must not include identity columns or computed columns). If you want to synchronize views that reference more than one table, the following procedure is recommended:

  1. Use SQL Data Compare to compare the views.

    Ensure that the Include views project option is selected.

  2. Note which rows are different.
  3. Use SQL Data Compare to compare and synchronize the tables that contain the differing rows.

See also

Working with projects

Filtering the comparison with a WHERE clause


Comparing databases on different SQL Server versions

If you are comparing databases that are on different versions of Microsoft® SQL Server™, you may encounter problems with some data types.

CLR data types

You can update CLR data in a SQL Server 2008 or SQL Server 2005 database with values from a text or string data type in a SQL Server 2000 database. Ensure that the project option Transport CLR data types as binary is not selected.

SQL Data Compare considers the collation for string data. Therefore, if the collation is not the same, differences are reported.

Note that if you are comparing backup files, SQL Data Compare can compare CLR data types only as binary values.

XML data types

You can update XML data in a SQL Server 2008 or SQL Server 2005 database with values from a text or string data type in a SQL Server 2000 database. SQL Data Compare will attempt to preserve white space. SQL Data Compare supports DTD (Document Type Definition), except for default attributes and entities.

Some data, such as XML encoding and DTD, cannot be stored in the SQL Server 2008 or SQL Server 2005 representation. Therefore, if you convert data from a string data type to an XML data type, and then you convert back to a string data type, this information will be lost.

SQL Data Compare considers the collation for string data. Therefore, if the collation is not the same, differences are reported.

Note that you cannot use an XML column as the comparison key.


Creating a rollback script

If you want to be able to reverse a synchronization, or to return a database to a specific state, you can create a rollback script.

Before you run the Synchronization Wizard:

  1. Right click in the Direction Bar, and click Switch synchronization direction
  2. Use the Synchronization Wizard to create and save a synchronization script.

For example, if you are migrating changes from WidgetStaging (the source) to WidgetProduction (the target), switching the synchronization direction makes WidgetProduction the source, and the synchronization script you create can be run on WidgetProduction in future to restore it to its current state.

You can also use SQL Data Compare to restore rows selectively from a backup.


Setting up the comparison

In this chapter

  • Which data types can be compared?
  • Working with projects
  • Setting data sources
  • Selecting tables and views
  • Mapping objects
  • Mapping owners
  • Filtering the comparison with a WHERE clause
  • Setting project options
  • Setting application options


Which data types can be compared?

SQL Data Compare can compare similar data types, however, there is a risk of truncation in some cases.

The table below shows which data types can be compared:

See also

Setting data sources

Getting started


Working with projects

Whenever you compare databases, you set up a project. If you have any existing projects, the Project Configuration dialog box for your most recently used project is displayed when you start SQL Data Compare.

A project contains details of:

  • which data sources you selected

    If you selected a backup as a data source, the project saves details of the backup set you selected.

  • the connection details for your data sources
  • which project configuration options you selected
  • which objects you have selected for synchronization
  • your owner mappings
  • your object mappings
  • which tables and views you selected
  • any WHERE clause you have used to filter the results

Finding a project

On the toolbar, click [image] (Open Project) to display the Projects dialog box:

The Projects dialog box shows details of your projects.

You can edit or compare these projects, or create a new project.

Creating and editing a project

To create a new project, click [image] New

To edit the current project, click [image] Edit

To open and edit an existing project, double click the project on the Projects dialog box.

Saving a project

SQL Data Compare does not automatically save projects.

To save a project, on the Project Configuration dialog box click Save. Alternatively, you can save a project when you are reviewing its comparison results. To do this, on the File menu click Save Project.

If there are unsaved changes in the current project, you will be prompted to save when you create a new project, open another project, or when you close the application.

Copying a project

To make a copy of a project, on the Projects dialog box, select the project, right click, and select Create Clone.

Alternatively, open the project that you want to copy, and on the Project Configuration dialog box, click Save As.

To copy a project when you are reviewing the comparison results, on the File menu, click Save Project As.

Project compatibility

You can open a SQL Data Compare 7, 6, or 5 project in version 8. Projects from earlier versions are not supported.

You cannot open a SQL Data Compare 8 project in earlier versions.

If you open and save a project in SQL Data Compare 8, it is converted to version 8 and cannot be opened in earlier versions.

You can open a SQL Compare 8.1 (or later) project in SQL Data Compare 8.0 or later.

You can open a SQL Data Compare 8.0 (or later) project in SQL Compare 8.1 or later.

See also

Mapping objects

Selecting tables and views

Setting data sources

Setting project options

Setting application options


Setting data sources

When you create a new comparison project, SQL Data Compare requires information about which two data sources you want to compare, and how to connect to them. You enter this information on the Project Configuration dialog box.

Selecting data sources

Specify the two data sources you want to compare in the Data Sources tab. You specify a source and a target.

The source is the data source that will not change. The target is the data source that will change.

To switch the source and target, click

You can compare the following types of data source:

  • Databases

    Any database you can connect to on a SQL Server.

  • Backups

    Native SQL Server backups or Red Gate SQL Backup backups. You can specify a backup as a data source only if you are using SQL Data Compare Professional edition.

  • Scripts folders

    Scripts folders created using either SQL Data Compare or SQL Compare professional edition.

You can compare any combination of data source types in your project.

Selecting a database

  1. Under Source or Target, select Database.
  2. Type or select the name of the SQL Server in the Server box.

    If you experience problems selecting a SQL Server that is not running on the LAN, for example if you are accessing the SQL Server via an Internet connection, you may need to create an alias to the SQL Server using TCP/IP (refer to your SQL Server documentation for details). You can then type the alias name in the Server box to connect to the remote SQL Server.

    To refresh the Server list, right-click the box and click Refresh, or scroll to the top of the list and click Refresh.

  3. Select the authentication method, and for SQL Server authentication enter the User name and Password.

    If you want SQL Data Compare to remember your password, select the Save password check box.

  4. In the Database box, type or select the name of the database.

    To refresh the Database list, right-click the box and click Refresh, or scroll to the top of the list and click Refresh.

Selecting a backup

  1. Under Source or Target, select Backup.

  2. Click Add Backup Set Files to select all the files making up the backup set you want to compare.

    To specify a network path, type the full path, including the server name, for example:

    \\ServerName\MyFolder\MyFile

    If any of the files you add are encrypted, the Decrypt Backup Files dialog box is displayed. Enter the password to decrypt these files.

To use a differential backup as a data source, you must also add the associated full backup.

Note that SQL Data Compare does not support using partial, filegroup, or transaction log backups as a data source.

When you have added a backup set, one of the following icons is displayed:

The backup set is valid and complete.

Select the check box to use this backup as a data source.

The backup set you have selected cannot be used as a data source.

This error is shown if the backup is corrupted, or if you have selected a partial, filegroup, or transaction log backup.

One or more files in the backup set is encrypted.

Click the padlock icon to display the Decrypt Backup Files dialog box.

Either the backup set is incomplete, or a differential backup has been added without the corresponding full backup.

For more information, see Working with backups

Selecting a scripts folder

  1. Under Source or Target, select Scripts Folder.
  2. In the Scripts Folder box, select the folder, or click [image] to browse to the folder.

If the folder contains a file with this information, the values are read from that file; otherwise, default settings are used. Check that these settings are correct, and change them if required.

You can use a scripts folder as a data source only if it contains a database schema. You can create scripts folders using SQL Compare, and use SQL Data Compare to update them with static data. Alternatively, you can create a scripts folder using SQL Data Compare.

To create schema scripts in a folder using SQL Data Compare:

  1. On the Data Sources tab of the Project Configuration dialog box, select a database, backup, or existing valid scripts folder as the source.
  2. Under Target, select Scripts folder.
  3. In the Scripts folder box, Browse to or select the folder you want to use.

    If the folder does not contain valid scripts folder metadata, the option to create schema scripts is enabled.

  4. Click Create Schema Scripts
  5. The Create New Scripts Folder dialog box is displayed:

To update the target scripts folder with data from the source, perform the comparison, select the rows you want to include, and then synchronize.

For more information, see Working with scripts folders

See also

Mapping objects

Setting project options

Selecting tables and views

Viewing the comparison results


Selecting tables and views

When you create a project and you have selected your data sources, you can specify which tables, views, and columns to compare. You enter this information using the Tables & Views tab on the Project Configuration dialog box.

The Tables & Views tab enables you to:

  • select the comparison key for each table or view
  • select the tables and views that will be compared
  • select the columns that will be compared

SQL Data Compare lists the tables and views in the source and target. Tables and views with identical or similar names are displayed side-by-side:

Note that:

  • You can filter the specific rows that will be compared by entering a WHERE clause. Filtering can improve the performance of SQL Data Compare.

    To filter rows, click WHERE Clause. The WHERE Clause Editor dialog box is displayed.

    For more information, see Filtering the comparison results with a WHERE clause

  • Views are listed only if the data source is a database and the project option Include views is selected.
  • You can change the order in which the tables and views are listed by clicking a column header.

    To sort by multiple columns, click a column header, then hold down SHIFT and click another column header.

  • Only the tables and views that are mapped are listed.

    If you are setting up a new project and SQL Data Compare is unable to map a table or view, you can map the tables and views manually.

    For more information, see Mapping objects

  • If you are editing an existing project and the structure of the database has changed since you last ran the project, the mappings may be incorrect. In this case, a warning symbol [image] is shown to indicate that those changes affect your project configuration.

    For more information, see Mapping errors

Selecting the comparison key

To match rows in the two data sources, SQL Data Compare requires a comparison key for each table or view.

SQL Data Compare automatically selects a comparison key when:

  • tables contain a matching primary key, unique index, or unique constraint
  • views contain a matching unique clustered index

If SQL Data Compare is unable to identify a suitable comparison key for a table or view, Not Set is shown in the Comparison Key box.

To set the comparison key for an object, click its Comparison Key box. A dialog box is displayed on which you can select the columns that will comprise the key:

Note that:

  • A comparison key cannot include columns whose data type is image, ntext, nvarchar(max), sql_variant, text, varbinary(max), varchar(max), or xml.
  • You cannot specify custom comparison keys if you are using a backup as a data source; however, you can select an alternative unique index or unique constraint.

For large databases, specifying a clustered index as the comparison key can result in improved performance.

Selecting the tables and views

Select the tables and views you want to compare by selecting or clearing the appropriate check boxes in the Compare column. To compare all tables and views, click [image] All; to clear all of the check boxes, click [image] None.

By default, the first time that you run a project all tables and views with identical or similar names are selected for comparison.

If the structure of the data sources you are comparing has changed while you are working on the project, click [image] Refresh to update the Tables & Views tab. For example, if a table has been added to the database, click [image] Refresh so that you can include the new table in the comparison.

If a table or view has been added to a database since you last ran the project, SQL Data Compare does not select the table or view by default.

For more information, see Mapping objects

Selecting columns

SQL Data Compare displays the number of columns that will be compared for each table or view. By default, the first time that you run a project, all columns with identical or similar names are selected for comparison.

You can filter the comparison to consider only specific columns.

To select the columns to compare in a table, click on it in the Columns in Comparison column. A dialog box is displayed with check boxes to include or exclude each column:

You cannot exclude any columns that are used for the comparison key (indicated by [image]).

A warning symbol [image] is shown when columns you are comparing cannot be mapped. This occurs if those columns have:

  • column names that do not match
  • incompatible data types

Note that:

  • you can compare a timestamp column with another timestamp column but you cannot synchronize timestamp columns.
  • You can compare an xml column with another xml column but you must ensure that your XML schemas are compatible.

For more information about the data types that SQL Data Compare can compare, see Which data types can be compared?

See also

Viewing the comparison results

Setting project options

Setting data sources

Mapping objects


Mapping objects

When you have selected your data sources, SQL Data Compare automatically maps tables and views with the same name and schema (owner).

However, if there are schema differences between the data sources, for example if two tables have different names, they may not be mapped automatically.

This topic provides information on

  • Mapping tables and views
  • Mapping specific columns

To compare tables and views that are not automatically mapped, click the Object Mapping tab of the Project Configuration dialog box :

The upper pane displays tables and views that are fully Mapped or have Partial mapping. The lower pane displays Unmapped tables and views.

Note that:

  • Views are listed only if the data source is a database and the project option Include views is selected.
  • If an object has a Partial mapping, some of its columns are not be mapped, and cannot be compared.

    To set the column mappings for an object, click the Status box for the object you want to re-map.

  • If the differences between objects are not significant, they are more likely to be automatically mapped if you select the options Ignore case of object names, Ignore spaces in object names, and Ignore underscores in object names
  • If you are editing an existing project and the structure of the database has changed since you last ran the project, a warning symbol [image] is shown to indicate that those changes affect your project configuration.

Mapping tables and views

To map tables and views:

  1. On the Object Mapping tab, select an Unmapped table or view that you want to map from the source database.
  2. Select the Unmapped table or view that you want to map from the target database.
  3. Click [image] Map.

    SQL Data Compare moves the tables or views to the upper pane.

Note that if the tables and views that you are mapping contain columns with incompatible data types, SQL Data Compare cannot compare those columns; the column mapping shows the incompatible data types as Uncomparable and a warning symbol [image] is shown in the Tables & Views tab.

For more information, see Which data types can be compared?

To unmap tables and views:

  1. On the Object mapping tab, select a Mapped table or view, or a Partial mapping.
  2. Click [image] Unmap.

SQL Data Compare moves the tables or views to the lower pane.

Mapping specific columns

If you want to compare columns in a table or view and the column names are different, you can map the columns as required.

To map columns:

  1. On the Object mapping tab, click the Status box of a Partial mapping.

    A dialog box is displayed. For example:

  2. Select an Unmapped column that you want to map from the source database.
  3. Select an Unmapped column that you want to map from the target database.
  4. Click [image] Map.

    SQL Data Compare moves the columns to the upper pane of the dialog box.

  5. Click Close.

Note that if a column is shown as Uncomparable, SQL Data Compare cannot compare the data that is stored in the column.

For more information, see Which data types can be compared?

To unmap columns:

  1. On the Object mapping tab, click the Status box of a Mapped table or view, or a Partial mapping.

    A dialog box is displayed for you to specify the column mappings, as shown above.

  2. Select a Mapped column.
  3. Click [image] Unmap.

    SQL Data Compare moves the columns to the lower pane of the dialog box.

  4. Click Close.

See also

Selecting tables and views

Setting data sources

Setting project options

Data that was not synchronized


Mapping owners

When you set up a project and you select your data sources, SQL Data Compare automatically maps objects with the same name and the same owner (SQL Server 2000) or schema (SQL Server 2008 and SQL Server 2005) for you.

If you want to compare objects with the same name, but those objects have different owners or belong to different schemas, you can map the owners or schemas as required. For example, if you want to compare objects in a test database that are owned by sales with objects in a production database that are owned by support, you can map sales to support.

For example:

If you map the owners (or schemas) sales and support, this enables SQL Compare to compare the stored procedures [sales].[editCustomerDetails] and [support].[editCustomerDetails].

SQL Data Compare can then rename other objects that are referenced by the stored procedure. For example, if the [support].[editCustomerDetails] stored procedure references the table [support].[customerDetails], the stored procedure is updated to reference the table [sales].[customerDetails]. The same applies to functions, DML triggers, DDL triggers, views, defaults, and rules.

Tables in a schema that is not mapped are not compared. For example, if you unmap the schemas Sales and Support, and then map Support to Sales, the comparison will fail for all tables owned by Sales if you do not also map Sales to another schema.

Editing the owner mappings

To display the Owner Mapping tab, on the Project Configuration dialog box click Owner Mapping.

The Owner Mapping tab allows you to map different owners (schemas).

The upper pane displays a list of schemas, database roles, and database users that SQL Data Compare has automatically mapped for you; the lower pane displays a list of schemas, database roles, and database users that are not mapped.

  • To undo a mapping, in the upper pane, select the mapping, and click [image] Unmap.
  • To create a mapping, in the lower pane, select an owner from the source, then select a corresponding owner from the target, and click [image] Map.

    For example, to map sales to support, you create a mapping for sales to support and then you create a mapping for support to sales.

    To reset the mappings to the defaults, click Restore Default Mappings.

See also

Which data types can be compared?

Working with projects

Setting data sources

Selecting tables and views

Mapping objects

Filtering the comparison with a WHERE clause

Setting project options

Setting application options


Filtering the comparison with a WHERE clause

You can filter the rows that will be compared by applying a WHERE clause to the comparison. This is useful, for example, if you want to exclude a particular set of test data, or to speed up the comparison.

Note that:

  • You can only filter rows if the data source is a database. WHERE clauses are not available for backups and scripts folders.
  • The WHERE Clause Editor does not validate the WHERE clauses. The clauses are validated when the databases are compared.

To specify a WHERE clause for a table, on the Tables & Views tab, double click the table, or select it and click [image] WHERE Clause

The WHERE Clause Editor is displayed:

To apply the same WHERE clause to multiple tables, use SHIFT+Click or CTRL+Click. Alternatively, you can right-click the tables or views and click Open WHERE clause editor.

Type a valid Transact-SQL WHERE clause. For example, if a table has columns ID, FirstName, and LastName, you may want to compare only rows where LastName is Smith. To do this, type the following in the box:

LastName='Smith'

Click OK. In the Tables & Views tab, [image] indicates that the table or view will be filtered using a WHERE clause.

If you want to apply a different WHERE clause for each data source, clear the Use the same WHERE clause for both data sources check box and type the WHERE clause in the box for the database on the right.

For example, if you have two databases for two different time zones that are 5 hours apart and you want to repair damaged data in one of the tables, you can specify a different WHERE clause in each database for that table.

Since you know approximately when the problem occurred, you can limit the number of rows that are compared. Clear the Use the same WHERE clause for both data sources check box, and specify WHERE clauses for each data source.

Alternatively, you can construct a simple view on the table in both databases. You can then use SQL Data Compare to compare the views.

See also

Synchronizing views

Selecting tables and views


Setting project options

The project configuration options enable you to modify the behavior of SQL Data Compare. For example, you can set an option so that SQL Data Compare ignores certain objects even if they are different, or so that it does not script certain properties for synchronization (such as the collation order on columns).

When you create a new project, you should run the comparison with the default options, then review your comparison results. However, if your database is on a SQL Server with case-sensitive sort order, you must select the Treat items as case sensitive option. When you have reviewed your comparison results, you may then want to consider changing some of the options.

The options you set are saved for each project, and are modified on the Project Configuration dialog box.

To display the Project Configuration dialog box, click [image] (Edit Project), or select Project Options from the Tools menu.

The options you can set are described below. Note that some of the options apply only to the comparison; they do not affect the synchronization. Similarly, some options apply only to the synchronization. Options affecting mapping and comparison (for example, those relating to case sensitivity) are not applied instantly. You must re-compare the data sources to apply these options.

Default options

To save the current selection of options as your defaults, click Save As My Defaults. To restore your defaults, click My Defaults. The saved defaults will be used for all new projects.

To reset all the options to their original settings, click Red Gate Defaults. The default options for a comparison project are as follows:

  • Ignore spaces in object names
  • Include identity columns
  • Include timestamp columns
  • Show identical values in results
  • Disable foreign keys
  • Reseed identity columns
  • Include comment header in the synchronization script

Use case sensitive object definition

Considers the case of the object names (tables, views, users, roles, schemas, indexes, and columns) when mapping. For example, [dbo].[Widget] will be mapped to [dbo].[wIDgEt].

Note that if the databases that you are comparing are running on a SQL Server that uses case-sensitive sort order, you should ensure that this option is selected.

Ignore spaces in object names

Ignores spaces in object names (tables, views, users, roles, schemas, indexes, and columns) when mapping. For example, [dbo].[Widget Prices] will be mapped to [dbo].[WidgetPrices].

Ignore underscores in object names

Ignores underscores in the object names (tables, views, users, roles, schemas, indexes, and columns) when mapping. For example, [dbo].[Widget_Prices] will be mapped to [dbo].[WidgetPrices].

Include views

Includes views in the comparison. Generally, views can be synchronized only if the referenced rows are from a single table, and the referenced columns are simple (for example, they must not include identity columns or computed columns).

Include identity columns

Includes identity columns in the comparison. You cannot synchronize a view if it includes an identity column.

Include timestamp columns

Includes timestamp columns in the comparison. Timestamp columns cannot be synchronized.

Trim trailing spaces

If the data in two columns differs only by the number of spaces at the end of the string, SQL Data Compare considers the data to be identical. This option does not apply to CLR or XML columns.

Trailing spaces are ignored during synchronization, if this option is selected.

Force binary collation (case-sensitive)

For all string data types, forces binary collation irrespective of column collation, resulting in a case-sensitive comparison. When this option is selected and the comparison key is a string, this may result in slower performance because the indexes are not used.

Show identical values in results

If this option is not selected, identical values will not be stored on disk nor appear in the comparison results.

Use checksum comparison

Performs a checksum prior to comparison. The data is compared only if the checksums differ. Note that if the data differs only in text or image columns, the checksums will be identical and the data may be flagged incorrectly as identical.

On SQL Server 2000 db_owner permissions are required.

You cannot select this option when comparing scripts folders.

You cannot select this option if the Show identical values in results project option is selected.

Compress temporary files

Compresses the temporary files that SQL Data Compare generates while performing the comparison. This reduces the possibility of running out of temporary disk space when comparing very large databases.

When you select this option, you will not be able to sort the results of the comparison by clicking on a column header in the Row Differences pane.

Disable foreign keys

Disables then re-enables foreign keys in the synchronization SQL script. Note that in some circumstances foreign keys will be dropped and recreated rather than disabled and re-enabled.

Drop primary keys, indexes, and unique constraints

Drops then recreates primary keys, indexes, and unique constraints in the synchronization SQL script. If the primary key, index, or unique constraint is the comparison key, it cannot be dropped.

Don't use transactions in SQL scripts

Does not insert BEGIN TRANSACTION at the beginning of the synchronization SQL script and COMMIT TRANSACTION at the end of the synchronization SQL script.

Transport CLR data types as binary

Uses the binary representation of CLR types in the synchronization SQL script. If this option is not selected SQL Data Compare uses the string representation.

Disable DML triggers

Disables then re-enables DML triggers on tables and views in the synchronization SQL script.

Disable DDL triggers

Disables then re-enables DDL triggers in the synchronization SQL script.

Reseed identity columns

Reseeds identity columns so that identity values in the database you are updating match values in the source database.

Include comment header in the synchronization script

Includes a comment at the beginning of the synchronization script. The heading contains information about the data sources being synchronized, and the version of SQL Data Compare.

Don't include comments in the synchronization script

If comments are included, it is easier to locate objects in the synchronization script. However, the script is smaller if comments are not included.

Force constraints to be re-enabled with CHECK

Forces any constraints (for example, those on foreign keys) disabled by SQL Data Compare to be re-enabled with CHECK.

See also

Working with projects

Setting application options

Data that was not synchronized


Setting application options

The Application Options dialog box enables you to specify options such as the default editor for opening the synchronization script, or the location where that script is saved.

To display the Application Options dialog box, on the Tools menu, click Application Options.

Split transactions

By default, the synchronization script is enclosed in a single transaction. To use multiple transactions, select the application option Split transactions

You can specify the amount of data included in each transaction using the Maximum transaction size box.

If you do not want to use transactions in the synchronization script, select the project option Don't use transactions in the synchronization script

See also

Setting project options

Exporting the comparison results


Reviewing the comparison results

In this chapter

  • Viewing the comparison results
  • Tables and views that cannot be compared
  • Viewing the row differences
  • Viewing the data
  • Exporting the comparison results
  • Printing the comparison results


Viewing the comparison results

When you have compared the data sources, SQL Data Compare displays the comparison results in the upper (Results) pane. The upper pane displays all the tables, views, and groups of row differences you can select for synchronization.

To compare the data sources again using the same project configuration, and update the comparison results, click [image] Refresh

Objects are displayed grouped by how they differ between the two data sources, by whether they match what is typed in the Find box, or ungrouped. When you first run the comparison, the objects are grouped by Type of difference.

Object groups

To view the tables or views in a group, click [image] or click the grouping bar.

If you want to display the comparison results in a single list, in the Group by box, select No groups.

When objects are grouped by Type of difference, the Type column indicates the difference:

tables or views with differences in their rows

tables or views with identical rows only

tables or views that could not be compared

Tables or views with differences in their rows

The comparison results are displayed as follows:

  • Type indicates the type of object; a table [image] or view
  • Different displays the total number of differences for the object. Synchronize all of these rows to make the table or view identical.

    Use the check box to include or exclude all of the rows for synchronization.

  • Table Name displays the name of the table or view.
  • displays the number of rows for the table or view that exist in the source but not the target.

    Use the check box to include or exclude these rows for synchronization.

  • displays the number of rows for the table or view that exist in both databases but are different.

    Use the check box to include or exclude these rows for synchronization.

  • displays the number of rows for the table or view that exist in target but not the source.

    Use the check box to include or exclude these rows for synchronization.

  • Identical displays the total number of rows in the table or view that are identical.
  • Actions [image] displays a drop-down menu that enables you to select or clear the various check boxes.

    The Actions menu is not available if you are viewing the comparison results in a single list.

    For more information, see Setting up the synchronization

Tables or views with identical rows only

The comparison results are displayed as follows:

  • Type indicates the type of object; a table or view.
  • Identical displays the total number of identical rows within the table or view.

Finding tables and views

To locate objects, type the search text in the Find box. To select a recent search, click the Find arrow button

As you type, objects are grouped in the upper pane by whether they match or do not match what you type:

Note that the search is not case-sensitive.

To clear the Find box click the [image] button.

See also

Exporting the comparison results

Setting up the synchronization

Printing the comparison results

Viewing the data

Viewing the row differences


Tables and views that cannot be compared

Tables and views that cannot be compared are grouped in the upper (Results) pane. Objects cannot be compared if SQL Data Compare cannot automatically determine their object mappings, owner mappings, or a comparison key.

To compare an object that could not be compared initially, you can manually set the mappings and comparison keys.

Setting the mappings

If there are schema differences between the data sources, for example if a column has a different name in the source and target tables, you can map them on the Project Configuration dialog box.

For information on setting owner (schema) mappings, see Mapping owners

For information on mapping objects, or specific columns, see Mapping objects

Setting a comparison key

SQL Data Compare automatically selects a comparison key when:

  • tables contain a matching primary key, unique index, or unique constraint
  • views contain a matching unique clustered index

If SQL Data Compare is unable to identify a suitable comparison key for a table or view, Not Set is shown in the Comparison Key box.

To set the comparison key for an object, click its Comparison Key box. A dialog box is displayed on which you can select the columns that will comprise the key:

Note that:

  • A comparison key cannot include columns whose data type is image, ntext, nvarchar(max), sql_variant, text, varbinary(max), varchar(max), or xml.
  • You cannot specify custom comparison keys if you are using a backup as a data source; however, you can select an alternative unique index or unique constraint.
  • For large databases, specifying a clustered index as the comparison key can result in improved performance.

See also

Mapping objects

Mapping owners

Which data types can be compared?


Viewing the row differences

The lower (Row Differences) pane displays a side-by-side listing of values for the tables and views you have compared. To display the lower pane, click a table or view in the list of tables.

By default, all rows with differences are selected for synchronization. Use the Include check boxes to include or exclude the rows.

Rows that contain differences are displayed with a shaded background

Values that are different are displayed with a darker shaded background

Values that exist in one database but do not exist in the other are displayed with a shaded, patterned background.

In the example above, for the row where WidgetId is 2:

  • Description is the same in both databases so the data is displayed in gray text
  • The Picture values are different so they are displayed with the darker shaded background
  • WidgetID is the comparison key.

Shading on the column names also indicates differences. A column name with full shading indicates values that are different; a column name with partial shading indicates values that only exist in one of the data sources. In the illustration above, the Picture column contains values that are different so the column name is displayed with full shading.

Note that:

  • The lower (Row Differences) pane cannot display values for tables or views that could not be compared.

    For more information, see Tables and views that cannot be compared

  • If you have cleared the Show identical values in results project option, SQL Data Compare does not show rows that are identical and a warning symbol [image] is displayed.
  • If you have selected the project option Compress temporary files, you will be unable to sort the comparison results by clicking on a column header.

    For more information, see Setting project options

Searching the data

To search the values, in the Find box, type your search text, then click [image] or [image] to find the next or previous match. If the Find box is not already displayed, right-click and click Find.

Viewing the object synchronization script

To view the synchronization script for the selected object, right-click, and click Show Object Synchronization Script.

The Single Object Synchronization Script dialog box is displayed.

You are recommended to synchronize only using the full synchronization script created by the Synchronization Wizard, as the single objects script cannot account for dependencies. If you use the object synchronization script to synchronize a single object, there may be unexpected results, or the synchronization may fail.

To view the synchronization SQL that will make all the selected tables and views in the two data sources identical, use the Synchronization wizard.

Pivoting the data

To rotate the data so that you can view the values for a record as a group, click Show, and select Pivot View ; the values are displayed vertically. This is useful when there are a large number of columns in a table.

Note that you cannot change the sort order of the columns when you are viewing the data in the pivot view.

To scroll through the records, hold down SHIFT and rotate the mouse wheel.

To show the next or previous difference, use the arrow buttons or press the shortcut keys; the values that differ are shown with a green background.

Viewing the data

The Viewer dialog box displays value details.

For more information, see Viewing the data.

See also

Viewing the comparison results

Viewing the data

Printing the comparison results

Setting up the synchronization

Exporting the comparison results


Viewing the data

The Viewer dialog box displays value details. To display the Viewer dialog box, double-click a value in the lower (Row Differences) pane.

For example, if a value exists in only one of the data sources:

If the row exists in both databases but the values are different, the values are shown side-by-side, and the differences are highlighted.

Use the [image] Previous and [image] Next buttons to go to the previous or next line with a difference.

To view the individual spaces, select the Show white space check box.

If the value is a binary value, such as an image, click the Binary Data link to view the details, for example:

You can select the required format in which to display the data.

Searching the value details

For string values, you can search the value details by right-clicking, and clicking Find. In the Find box, type your search text and click [image] or [image] to find the next or previous match. If there are no further matches, the Find box changes color. If the value details are displayed side-by-side, to search the value details in the other data source, click Find on this Side.

To copy the value details for use in another application, select the data, right-click, and then click Copy. Alternatively, right-click, click Select All, then right-click, and click Copy.

See also

Viewing the comparison results

Viewing the row differences


Exporting the comparison results

When you have run a comparison, you can export the comparison, or a subset of the results, to a collection of comma-separated value (CSV) files. For example, you may want to produce a detailed report or to keep a record of the comparison results.

  1. On the Tools menu, click Export Comparison Results.

    The Export Comparison Results dialog box is displayed.

  2. Type the path for the export files in the Export to box, or click Browse to choose the export folder.

    You can change the default path in the Application Options dialog box.

  3. Select the check box in the Export column for the tables or views that you want to export.

    You can right-click the list of tables and views and click Include All to select all the check boxes or Exclude All to clear all the check boxes.

  4. Under Rows to Include, select the check boxes for the rows that you want to export:
    • Identical includes rows that are the same in both databases.
    • Different includes rows that exist in both databases but are different.
    • Only in database name includes rows that exist only in that database.
  5. Click Export.

For each selected table or view and for each of the row types that you selected under Rows to Include, SQL Data Compare creates a separate CSV file. SQL Data Compare also creates a Results Summary file.

See also

Viewing the comparison results

Viewing the row differences

Setting application options

Printing the comparison results


Printing the comparison results

When you have run the comparison on the project, you can print a summary of the comparison results.

To see a preview of the summary, on the File menu, click Print Preview.

The Preview dialog box provides the following commands:

prints the summary

configures the page setup

zoom in or out

displays the first page, previous page, next page, or last page

See also

Viewing the comparison results


Synchronizing the data sources

In this chapter

  • Setting up the synchronization
  • Using the Synchronization wizard
  • Backing up before synchronization
  • Warnings
  • Data that was not synchronized


Setting up the synchronization

When you have reviewed the comparison results, select the rows you want to synchronize, and run the Synchronization wizard.

Selecting the rows to synchronize

By default, all rows that differ are selected for synchronization.

Use the check boxes in the upper (Results) pane to select rows for synchronization:

Object selections are remembered when you save a project.

  • All Different for all rows that are different for a table or view
  • for all rows in a table or view that exist in the source but do not exist in the target
  • for all rows in a table or view that exist in both databases but the rows are different
  • for all rows in a table or view that exist in thetarget but do not exist in the source

You can also use the Actions [image] drop-down menu to select rows:

  • Include All and Exclude All select and clear the check boxes for all rows.
  • Include All in Source and Exclude All in Source select and clear the check boxes in the [image] (only in source) column.
  • Include All Different and Exclude All Different select and clear the check boxes in the [image] (different) column.
  • Include All in Target or Exclude All in Target select and clear the check boxes in the [image] (only in target) column.

Note that the Actions [image] drop-down menu is not available if you are viewing the comparison results in a single list.

Use the lower (Row Differences) pane to select individual rows to synchronize:

  1. Click a table or view to display its row differences.
  2. Click the appropriate tab to view the type of row differences.
  3. Select or clear the check boxes in the Include column as required.

Selecting the rows to synchronize using keyboard shortcuts

To select a row for synchronization, highlight the row and press SPACEBAR to select or clear its check box.

To highlight multiple rows:

  • For the previous or next row, press SHIFT+UP or SHIFT+DOWN
  • For all rows from the current row to the first or last row, press CTRL+SHIFT+HOME or CTRL+SHIFT+END
  • For all rows, press CTRL+A

You can also use SHIFT+Click and CTRL+Click to highlight multiple rows.

See also

Viewing the comparison results

Viewing the row differences


Using the Synchronization wizard

When you have selected the objects that you want to include in the synchronization, use the Synchronization Wizard to create the SQL script that will synchronize the databases.

To start the Synchronization Wizard, click [image] Synchronization Wizard

The wizard has three steps:

  1. Choose synchronization method

    Create and save a script, perform the synchronization from SQL Data Compare, or update a scripts folder.

  2. Configure Backup (optional step)

    If you do not choose to back up on the first page, this step is not part of the wizard.

  3. Review

    View the synchronization script, review a summary of the synchronization actions, and see any warnings.

If SQL Data Compare is unable to synchronize the data sources, an error message is displayed, and where possible all changes are rolled back. However, if you have disabled the project option Use transactions in SQL scripts, the changes are not rolled back.

Synchronizing backups

When you have selected a backup as the target, the synchronization wizard creates a script to update the database from which the backup was created. Backups cannot be modified directly.

When a backup is the source, and a database is the target, the database can be synchronized with the backup.

For more information, see Working with backups

Synchronizing scripts folders

When a scripts folder is the target, you can either:

  • Create a synchronization script to update the database from which the scripts folder was created, or
  • Update files in the scripts folder directly

    Note that when an object is dropped during synchronization, its script file is not deleted.

If a scripts folder is the target, and any of the script files that will be modified are designated as read-only, then a warning is displayed. If you click Yes to continue, then these files will be made writable so that they can be modified. This may occur, for example, when you are working with a source control system that sets files to read-only status in some situations (if you are not using SQL Changeset for source control integration)

For more information, see Working with scripts folders

1. Choose synchronization method

On the first page of the Synchronization Wizard you can choose to create and save a synchronization script, perform the synchronization using SQL Data Compare, or update a scripts folder:

Create a synchronization script

If you choose to create a synchronization script, on the Review page you can save a copy of the script or open it in your SQL editor.

To change the application you use to open the script, click Change. The Application Options dialog box is displayed, and you can specify the default application used to edit SQL Scripts.

Synchronize using SQL Data Compare

If you choose to synchronize using SQL Data Compare, on the Review page you can save a copy of the script and exit the wizard, or click Synchronize Now to perform the synchronization.

If the target is a scripts folder, this option is instead replaced by Update the scripts folder, and the SQL script files in the target are modified when you synchronize.

If you select Back up target before synchronization, a step is added to the Synchronization Wizard allowing you to specify details of the backup.

Note that if the target is a backup, the option to synchronize using SQL Data Compare is not available. Instead, synchronizing creates a script to modify the data source form which the backup was created.

2. Configure backup (optional step)

If you selected the option to back up before synchronization, the Configure backup page is added to the Synchronization Wizard.

If the target is a database, this page allows you to perform a backup before synchronization.

If the target is a scripts folder, this option is not available.

Perform a full backup

When the target is a database, you can perform a full backup. In the Back up using box , select:

  • Native SQL Server to create a backup using the native SQL Server BACKUP command
  • Red Gate SQL Backup to create a backup using SQL Backup version 4 or later

    Note that to use Red Gate SQL Backup, you must have the SQL Backup server components installed on the SQL Server instance of the target database.

For more information, see Backing up before synchronization

3. Review

There are three tabs on the Review page:

  • Synchronization script shows the script to synchronize the data sources.

    You can search the script, save it, or copy it to the clipboard.

  • Summary shows a synopsis of the actions in the synchronization script.

    You can view the summary grouped by the objects affected, by the type of modification, or by the order in which the script modifies the target.

  • Warnings shows a list of any warnings about unexpected behavior that may occur when you synchronize the databases.

For more information, see Warnings

If you are updating or creating a scripts folder, the Files tab lists the object creation and data script files modified or created during synchronization.

When you have reviewed the script, click Synchronize Now to perform the synchronization.

See also

Setting up the synchronization

Backing up before synchronization

Warnings


Backing up before synchronization

The Configure Backup page of the Synchronization Wizard allows you to perform a full backup using either Red Gate SQL Backup, or SQL Server native backups.

Backup name and location

For SQL Server native:

  1. Type the file path in the Backup folder box or click [image] to specify the path using the folder browser. By default, Backup folder is set to the default backup folder for the SQL Server instance.
  2. Type the file name in the box to the right of the Backup folder box.

For Red Gate SQL Backup:

  1. Type the file path in the Backup folder box or click [image] to specify the path using the folder browser. By default, Backup folder is set to the folder specified in the SQL Backup options for the SQL Server instance. If no backup file locations have been set up, SQL Backup uses the SQL Server instance's default backup folder.
  2. Specify the file name in the box to the right of the Backup folder box. By default, the file name is set to <AUTO>.sqb; SQL Backup uses the SQL Backup options to generate the backup file path and file name. If no backup file locations have been set up, SQL Backup uses the SQL Server instance's default format for file names.

    To change the file name, clear the Name file automatically check box, and type the required file name. You can use SQL Backup tags, if required. For information about tags, see File Location Tags in the SQL Backup online help.

To specify a network path in the Backup folder box, type the full path, including the server name, for example \\ServerName\MyFolder

Note that the file path is relative to the selected SQL Server. For example, if you have chosen to back up a database on a remote SQL Server instance called ServerA and you specify a local path such as C:\Backups, the backup files will be created on the C: drive on ServerA, not on the local computer.

Select the Overwrite existing backup files of the same name check box if you want to overwrite any files of the same name that exist for the file path you specified in the Backup Folder box. Note that if a file of the same name exists already and you have not chosen to overwrite it, the backup will fail if you are using SQL Backup.

Backup compression (Red Gate SQL Backup only)

If you are using SQL Backup to back up the target database, you can choose from the three compression levels described below. Generally, the smaller the resulting backup file, the slower the backup process.

To compress the backup, select the Compress backup check box and select the compression level by moving the slider.

  • Compression level 3

    Compression level 3 uses the zlib compression algorithm. This compression level generates the smallest backup files in most cases, but it uses the most CPU cycles and takes the longest to complete.

  • Compression level 2

    This compression level uses the zlib compression algorithm, and is a variation of compression level 3.

    On average, the backup process is 15% to 25% faster than when compression level 3 is used, and 12% to 14% fewer CPU cycles are used. Backup files are usually 4% to 6% larger.

  • Compression level 1

    This is the default compression level. It is the fastest compression, but results in larger backup files. On average, the backup process is 10% to 20% faster than when compression level 2 is used, and 20% to 33% fewer CPU cycles are used. Backup files are usually 5% to 9% larger than those produced by compression level 2. However, if a database contains frequently repeated values, compression level 1 can produce backup files that are smaller than if you used compression level 2 or 3. For example, this may occur for a database that contains the results of Microsoft SQL Profiler trace sessions.

Note that if SQL Backup Lite is installed on the SQL Server, you can choose only compression level 1.

Backup encryption (Red Gate SQL Backup only)

If you are using SQL Backup to back up the target database, you can encrypt the backup by selecting the Encrypt backup check box, then typing a password for the backup in Password, and again in Confirm.

If SQL Backup Pro is installed on the SQL Server, you can choose 128-bit or 256-bit encryption; if SQL Backup Standard is installed on the SQL Server, you can choose only 128-bit encryption; if SQL Backup Lite is installed on the SQL Server, you cannot encrypt the backup.

You must remember your password; if you do not, you will not be able to access the encrypted backup.

Using multiple threads (Red Gate SQL Backup only)

If you are using SQL Backup to back up the target database and you are using a multi-processor system, using multiple threads can speed up the backup process. Select the Use multiple threads check box and type or select the number of threads up to a maximum of 32. You are recommended to start with one thread fewer than the number of processors. For example, if you are using four processors, start with three threads.

For details of how you can find out the most effective number of threads to use for your setup, see Optimizing Backup Speed in the online help for SQL Backup.

See also

Setting up the synchronization

Using the Synchronization wizard

Warnings

Data that was not synchronized


Warnings

On the Summary page of the Synchronization wizard, you can click Warnings to view information about unexpected behavior that may occur when you synchronize the databases, or reasons the script may fail. The warnings are graded according to severity.

You can copy the warnings so that you can paste them into another application by clicking Copy Warnings to Clipboard.

Some of the warnings that SQL Data Compare may display are explained below.

Possible truncation error

SQL Data Compare displays this warning when the length setting of a character or binary column has changed. Data may be truncated in the synchronization SQL script.

Possible rounding error

This warning is displayed when the scale setting of a decimal or numeric column has changed. Data may be rounded in the synchronization SQL script.

Possible overflow error

This warning is displayed when the precision setting of a decimal or numeric column has changed. There may be overflows when the data is synchronized.

Conversion to XML

SQL Data Compare displays this warning when data is converted to an XML data type column. If the data is not valid XML, unexpected behavior may occur when you synchronize the databases.

Collation mismatch

SQL Data Compare displays this warning when the collation setting for a column has changed.

You can set SQL Data Compare so that binary collation is used on all character string sorting by selecting the Force binary collation (case- sensitive) project option.

See also

Using the Synchronization wizard


Data that was not synchronized

When you synchronize the data sources, some rows may not be synchronized if:

  • there are triggers defined on the tables

    If you have a trigger defined on a table that inserts data into another table on INSERT, DELETE, or UPDATE, the data in the tables will change as the synchronization is run, which will cause unpredictable results. To avoid this, select the Disable DML triggers project option before you generate the synchronization script.

  • primary keys are defined on columns with differing collations

    If you compare tables that have primary keys defined on columns that have different collations, SQL Data Compare may produce unpredictable results.

  • columns contain timestamp data

    SQL Data Compare cannot synchronize data in timestamp columns.

  • table structures are not identical

    If the structure of the tables that you are synchronizing is not identical, SQL Data Compare may produce unpredictable results.

CLR data that was not synchronized

Data for CLR types can be stored as string or binary values. When CLR data is compared, SQL Data Compare always compares the binary representations. However, by default, when CLR data is synchronized, SQL Data Compare synchronizes the string representations, because binary formats are not always compatible.

If the binary representations are not compatible, they are always displayed as different even if the string representations are identical. String representations do not always contain the full information about the data, so when the databases are re-compared using the binary representations following synchronization, they may be displayed as different.

If you know that the binary formats are compatible, you can select the project configuration option Transport CLR data types as binary.

This forces SQL Data Compare to synchronize the binary representations.

Primary keys, indexes, or unique constraints that were not dropped for synchronization

If you select the project configuration option Drop primary keys, indexes, and unique constraints, note that primary keys, indexes or unique constraints that are selected as comparison keys are not dropped for the synchronization.

See also

Setting up the synchronization

Warnings

Mapping objects

Mapping owners

Setting project options


Working with other data sources

In this chapter

  • Working with backups
  • Working with scripts folders


Working with backups

SQL Data Compare enables you to compare a backup with other data sources. This is useful, for example, when you want to retrieve the data from a backup and compare it with your database without running a restore operation or copying the backup from a remote network.

If you are comparing two backups, you do not need SQL Server to be installed on your computer.

Note that:

  • Comparing backups is available only in SQL Data Compare Professional edition.
  • SQL Data Compare can retrieve the data from full or differential backups. However, it does not support partial, filegroup, or transaction log backups.
  • When you run a comparison using a backup, SQL Data Compare locks the backup files when it reads them, and you cannot overwrite, move, or delete them.
  • SQL Data Compare does not read the log records of backup files, so if the database schema was modified while the backup was being created, it may not be shown as modified in the comparison results.
  • You can specify a backup as the target; however, note that backups cannot be modified.

Comparing and synchronizing backups

You can:

  • compare a backup with another data source

    See Setting data sources

  • create a synchronization script from a backup

When you have selected a backup as the target, the synchronization wizard creates a script to update the database from which the backup was created. Backups cannot be modified directly.

When a backup is the source, and a database is the target, the database can be synchronized with the backup.

Compatibility with backups

You can compare backups from SQL Server 2008, SQL Server 2005 or SQL Server 2000 databases.

To use a differential backup as a data source, you must also add the associated full backup.

Note that SQL Data Compare does not support using partial, filegroup, or transaction log backups as a data source.

SQL Data Compare supports:

  • native SQL Server backups
  • SQL Backup backups

    You can use backups created with SQL Backup version 3 or later; you can use compressed or encrypted backups.

When you set up a comparison that uses backup files, SQL Data Compare does not support:

  • tables that do not have a primary key, unique index, or unique constraint
  • views
  • computed columns

    However, you can compare persisted computed columns.

  • string representations of CLR types

    Only the binary representation is supported.

  • custom comparison keys

    However, you can select an alternative unique index, or unique constraint.

  • row filtering using the WHERE Clause Editor

See also

Setting data sources

Working with scripts folders


Working with scripts folders

A scripts folder is a set of object creation scripts representing a database's schema and (optionally) data. A script file is created for each object, and different object types are stored within subfolders you can specify.

You can use scripts folders:

  • for version control of databases

    For example, you may want to store the script files in a source control system, so that you can track the modified or new objects.

  • to compare databases on unconnected SQL Servers

You can create and compare scripts folders only if you are using SQL Data Compare Professional Edition.

For an example using scripts folders, see Deploying a database from source control

What's stored in a scripts folder?

  • Object creation scripts

    A .sql file containing creation scripts is saved for each object in the schema.

  • Static data scripts (optional)

    A .sql file containing INSERT scripts is saved for each table.

  • Database and schema metadata

    A .sdcs file is saved for each table. These files contain index information that enables SQL Data Compare to compare static data.

    The file RedGateDatabaseInfo.xml contains information about the objects in the schema, the SQL Server version, and the collation of the database from which the scripts folder was created.

    You are recommended not to delete or modify these files.

Creating a scripts folder

In SQL Data Compare you can create a scripts folder from an existing data source when you are setting up the comparison.

A new scripts folder does not contain any static data. To update the target scripts folder with data from the source, perform the comparison, select the rows you want to include, and then synchronize.

To create a scripts folder:

  1. On the Data Sources tab of the Project Configuration dialog box, select a database, backup, or existing valid scripts folder as the source.
  2. Under Target, select Scripts folder.
  3. In the Scripts folder box, Browse to or select the folder you want to use.

    If the folder does not contain valid scripts folder metadata, the option to create schema scripts is enabled.

  4. Click Create Schema Scripts
  5. The Create New Scripts Folder dialog box is displayed:

Under Data source details, specify the details of the source for the scripts folder. You can create a scripts folder from a database, backup, snapshot, or another scripts folder.

Under Scripts folder properties, specify a name and location for the scripts folder.

SQL Data Compare automatically detects the case sensitivity of the data source. If you want to override this, clear the Auto detect case sensitivity check box, and select the Treat items as case sensitive check box if required.

By default, SQL Data Compare decrypts text objects in SQL Server 2008 and SQL Server 2005 databases that were created using the WITH ENCRYPTION option. When comparing large databases, selecting this option can result in slower performance.

Additionally, you can customize the folder structure and character encoding of the scripts folder. To do this, click Scripts creation options. The Edit Scripts Creation Options dialog box is displayed, allowing you to specify the directories in which your database objects and static data are saved.

Note that:

  • when the source is a snapshot, the case sensitivity and decryption options are not available
  • when the source is a scripts folder, the decryption option is not available

Comparing and synchronizing scripts folders

You can:

  • compare a scripts folder with another data source

    See Setting data sources

  • synchronize a scripts folder

When a scripts folder is the target, you can either:

  • Create a synchronization script to update the database from which the scripts folder was created, or
  • Update files in the scripts folder directly

    Note that when an object is dropped during synchronization, its script file is not deleted.

If a scripts folder is the target, and any of the script files that will be modified are designated as read-only, then a warning is displayed. If you click Yes to continue, then these files will be made writable so that they can be modified. This may occur, for example, when you are working with a source control system that sets files to read-only status in some situations (if you are not using SQL Changeset for source control integration)

For more information, see Using the Synchronization wizard

More information about scripts folders

This section provides further information about using scripts folders as a data source in SQL Data Compare.

  • White space

    SQL Server does not always process white space and comments correctly at the beginning and end of the object definition for some objects such as views, stored procedures, and rules. You are therefore recommended to select the Ignore White Space option when you use a scripts folder as a data source.

  • Comments

    When you select a scripts folder as the target data source, SQL Data Compare preserves comments in object types such as views and stored procedures. However, this is not possible for non-textual object types such as tables. Comments that are part of a table definition will be lost when the table is modified and the object creation script updated.

See also

Keeping a database in source control

Working with backups

Setting data sources


The command line interface

In this chapter

  • Getting started with the SQL Data Compare command line
  • Changes to the command line in SQL Data Compare 8
  • Command line basics
  • Integrating the command line with applications
  • Examples using the command line
  • Command line syntax


Getting started with the SQL Data Compare command line

The command line interface provides access to the functionality of SQL Data Compare. For example, using the command line interface you can:

  • automate the comparison and synchronization of database schema
  • perform scheduled comparisons and synchronizations
  • synchronize multiple databases

You invoke the command line either from a script, such as a batch script or VBScript, or by using the facilities provided by compiled languages such as VB, C++ and C#.

Prerequisites

To use the SQL Data Compare command line interface, you must have:

  • A SQL Data Compare Professional Edition, or SQL Toolbelt license
  • If you do not have a license, you can use the command line for 14 days.
  • .NET framework version 2.0 or later

    This is required to run the command line interface, but it is not required when you develop applications and scripts that use the command line interface.

  • MDAC 2.8 or later

See also

Changes to the command line in SQL Data Compare 8

Integrating the command line with applications

Using XML to specify command line arguments

Simple examples using the command line


Changes to the command line in SQL Data Compare 8

These changes coincide with the release of SQL Compare 8, and are intended to make command line syntax more consistent between SQL Compare and SQL Data Compare.

In SQL Data Compare 8, there are changes to the names and functions of some command line switches and options, as well as their aliases.

The command line syntax of previous versions of SQL Data Compare is considered deprecated, but continues to be supported.

For example, in SQL Data Compare 7, the alias for /BackupSet1 was /bs1. In SQL Data Compare 8, the alias is now /bks1. You can continue to use /bs1 in SQL Data Compare 8, but a message is displayed informing you of the new alias.

Deprecated command line syntax will cease to be supported at a future release.

This topic addresses the following:

  • Which switches have changed?
  • Which options have changed?
  • Changes to case sensitivity behaviour
  • Compatibility with earlier versions

Which switches have changed?

/AllowIdenticalDatabases

This switch is deprecated. Instead use /Include:Identical

/BackupSet1 and /BackupSet2

The aliases for these switches are now /bks1 and /bks2.

The functionality of these switches has not changed.

/CaseSensitive

This switch is deprecated. Instead use /Options:CaseSensitiveObjectDefinition

/Columns

This switch is deprecated. Instead use /IncludeColumns and /ExcludeColumns

/ExportIdenticalTables

This switch is deprecated. Instead use /Include:Identical

/IgnoreParserErrors

If SQL Data Compare encounters any high level errors when parsing a scripts folder, it will exit with an error code of 62.

Use /ignoreParserErrors to force SQL Data Compare to continue without exiting.

/Include and /Exclude

Specify which tables and views are included in the comparison.

/Include and /Exclude have the following arguments:

  • Additional

includes only those objects that are not present in the source (eg /db1)
  • Missing

includes only those objects that are not present in the target (eg /db2)
  • Different

includes only those objects that are present in both data sources, but are different.
  • Identical

Includes identical objects in the command line output and any generated reports.
  • User specified

includes the specific objects you specify with a regular expression

Note that if there is a conflict, /Exclude takes precedence over /Include

/IncludeColumns and /ExcludeColumns

Specifies which columns in a table are included in or excluded from the comparison.

Note that /ExcludeColumns takes precedence over /IncludeColumns

/IncludeAdditional

This switch is deprecated. Instead use /Include:Additional

/ScriptFile

Alias: /sf

Generates a SQL script to migrate the changes which can be executed at a later time. If the file already exists an error will occur, unless you use the /force switch:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/ScriptFile: "C:\Scripts Folder\WidgetSyncScript.sql"

/scriptfile can be used when the target ( /db2, /scr2, /sn2 ) is a database, a snapshot, or a scripts folder.

If the target is a snapshot or a scripts folder, the generated script modifies a database with the schema represented by that snapshot or scripts folder.

Which options have changed?

DDLTriggerDisable

This option has been renamed: DisableAndReenableDDLTriggers, with the alias drd

DisableDMLTriggers

This option has been renamed: DisableAndReenableDMLTriggers, with the alias t

ForceCheck

New option. Forces any constraints (for example, those on foreign keys) disabled by SQL Data Compare to be re-enabled with CHECK.

IgnoreCase

This option is deprecated. Case insensitive comparison is now the default behaviour.

Changes to case sensitivity behaviour

In earlier versions of SQL Data Compare the case sensitivity behaviour of the command line interface was inconsistent.

/CaseSensitive affected the matching of object names for the /Include, /Exclude, /Columns, and /ComparisonKeys switches. The option IgnoreCase was on by default, and affected the case sensitivity of object and owner mapping.

These behaviours are now deprecated, and all switches and mappings share the same case sensitivity behaviour.

In SQL Data Compare 8:

  • the default setting is case insensitive
  • case sensitivity is set using /Options:CaseSensitiveObjectDefinition

Compatibility with earlier versions

Although the command line syntax of previous versions of SQL Data Compare is considered deprecated, it continues to be supported.

If you use deprecated syntax, a warning is displayed, but SQL Data Compare functions normally.

Note that for case sensitivity, the new syntax takes precedence. For example, if you set both /Options:CaseSensitiveObjectDefinition and /Options:IgnoreCase, the command line behaviour is case sensitive.

You are recommended to use the new syntax. Deprecated command line syntax will cease to be supported at a future release.

See also

Command line basics

Switches used in the command line

Options used in the command line

Exit codes used in the command line


Command line basics

This topic provides information on the following aspects of the SQL Data Compare command line:

  • Getting help
  • Entering a command
  • Aliases
  • The /Options switch
  • Verbose and quiet switches
  • Redirecting command line output

For details and examples of all of the switches that are available for the SQL Data Compare command line, see Switches used in the command line

Getting help

To display a brief description of SQL Data Compare, and basic help on all the command line switches, enter:

sqldatacompare /Help

For more detailed help enter:

sqldatacompare /Help /Verbose

This displays a detailed description of each switch and the values it can accept (where applicable), and all exit codes. To output the help in HTML format, enter:

sqldatacompare /Help /Verbose /Html

Entering a command

When you enter a command, the order of switches is unimportant.

You are recommended to follow the Microsoft convention of separating a switch from its values using a colon as shown below.

/Out:Output.txt

Values that include spaces must be delimited by double quotation marks ( " ). For example:

/Out:"c:\output file.txt"

Note that if you delimit a path with double quotation marks, you must not terminate the path with the backslash character ( \ ), because the backslash will be interpreted as an escape character. For example:

Incorrect: /Location:"C:\Packages\"

Correct: /Location:"C:\Packages"

For switches that accept multiple values, use commas to separate the values. For example:

/Options:IncludeDependencies,ForceColumnOrder

For switches that accept a compound value, separate each part of the value using a colon.

For example, the /include and /exclude switches are used to include and exclude objects from the comparison and synchronization:

/Include:Table:Product

This includes all tables for which the table name contains the word Product.

Note that if you use the /include switch to compare only tables (or any object type) matching a word or regular expression, all other objects not of that type will still be included in the comparison. In the above example, only tables that contain the word Product will be included, but all views, stored procedures, users and so on will still be included, unless further arguments to limit these object types are also specified.

Aliases

Many of the switches have an alias. The alias provides a convenient short-hand way to specify the switch. For example, /? is the alias for the /help switch, and /v is the alias for the /verbose switch.

Switches and aliases are not case sensitive.

The /Options switch

You can use the /Options switch to change your options. For example, comparisons are not case-sensitive by default; to specify case sensitive comparisons you would use the /options switch:

/Options:CaseSensitiveObjectDefinition

However, note that if you set any options explicitly, all of the default options are switched off.

For more information about options, and a list of default option settings, see Options used in the command line

Verbose and quiet switches

The standard output mode prints basic information about what the tool is doing while it is executing. You can specify verbose and quiet modes using the /verbose and /quiet switches, respectively. In verbose mode, detailed output is printed; in quiet mode, output is printed only if an error occurs.

Redirecting command line output

The command line output can be redirect using either the /out switch, or the output redirection features provided by the shell in which you are executing the command.

Using /out

You can use the /out switch to specify the file to which you want output directed:

sqldatacompare ... /Out:outputlog.txt

where outputlog.txt is the name of the file. If the file exists already, you must also use the /force switch to force the tool to overwrite the file, otherwise an error will occur.

Other redirection

From the standard command prompt provided by Windows, you can redirect output to a file as follows:

sqldatacompare ... > outputlog.txt

Note that the redirection operator ( > ) and file name must be the last items on the command line.

If the specified file exists already, it will be overwritten. To append output from the tool to an existing file, enter the following:

sqldatacompare... >> existinglog.txt

This adds the output to the existing file content, without data being lost.

If you are scripting using a language such as VBScript, JScript, PHP, Perl, or Python, or if you want to access the tool from Web pages using ASP.NET, refer to the documentation for the language.

Specify command line arguments in an XML file that can be referenced using the /argfile switch. For more on this topic see Using XML to specify command line arguments

See also

Getting started with the SQL Data Compare command line

Changes to the command line in SQL Data Compare 8

Integrating the command line with applications

Examples using the command line

Command line syntax


Integrating the command line with applications

To integrate the SQL Data Compare command line tool with applications that you distribute to your customers, you must have a license for the SQL Data Compare Professional Edition, or SQL Toolbelt. When you have a license and you execute the tool, the distribution files that you need to distribute the applications are generated. These files are marked with an asterisk (*) below.

The files that you should bundle into your application installer are listed below. The files should be installed in the same folder in which your application is installed.

  • RedGate.BackupReader.CryptoHelper.dll
  • RedGate.BackupReader.dll
  • RedGate.BackupReader.SqbReader.dll
  • RedGate.CommandLine.Common.dll
  • RedGate.Shared.Utils.dll
  • RedGate.Shared.SQL.dll
  • RedGate.SQLCompare.ASTParser.dll
  • RedGate.BackupReader.dll
  • RedGate.SQLCompare.Engine.dll
  • RedGate.SQLCompare.Rewriter.dll
  • RedGate.SQLDataCompare.CommandLine.dll
  • RedGate.SQLDataCompare.Distribution.dll*
  • RedGate.SQLDataCompare.Distribution.mod*
  • RedGate.SQLDataCompare.Engine.dll
  • rglz.dll
  • SQLDataCompare.exe
  • SQLDataCompare.exe.config
  • System.Data.SQLite.dll
  • zlib1.dll

See also

Using XML to specify command line arguments


Examples using the command line

In this chapter

  • Simple examples using the command line
  • Example: selecting single tables for comparison
  • Example: selecting tables with unrelated names
  • Using XML to specify command line arguments
  • Deploying a database from source control


Simple examples using the command line

This topic provides the following examples of how to use the command line interface:

  • Comparing and synchronizing database data

    Gives examples of comparison, synchronization, generating a report, specifying a comparison key, and using an existing project.

  • Using a backup as a data source

    Gives examples of specifying backups, multiple backups, and backup sets as a data source.

  • Scheduling a comparison

    Gives an example of using the Microsoft® Windows® Scheduled Task wizard to schedule a comparison.

For detailed examples of how to include specific tables, see:

  • Example: selecting single tables for comparison
  • Example: selecting tables with unrelated names

Comparing and synchronizing database data

To compare the data in WidgetDev and WidgetLive on the local instance:

sqldatacompare /Database1:WidgetDev /Database2:WidgetLive

To compare the data in WidgetDev and WidgetLive, and export the differences to .csv files:

sqldatacompare /Database1:WidgetDev /Database2:WidgetLive
/Export:"D:\SQLDataCompareReports"

To compare the data in WidgetDev and WidgetLive, and synchronize the databases by updating WidgetLive:

sqldatacompare /Database1:WidgetDev /Database2:WidgetLive
/Synchronize

To compare the data in WidgetDev and WidgetLive, specifying the comparison key for the Widgets table explicitly to be PK_Widgets:

sqldatacompare /Database1:WidgetDev /Database2:WidgetLive
/ComparisonKeys:Widgets:PK_Widgets

Note that you can specify a primary key or a unique index as the comparison key when you use the command line interface.

To use a project that you have previously created using the graphical user interface:

sqldatacompare /Project:"C:\SQLDataCompare\Projects\Widgets.sdc"

When you use a project, all tables and views that were selected for comparison when the project was saved are automatically included.

Note that:

  • you cannot use /project with /include or /exclude
  • all project configuration details - such as column settings, custom comparison keys, and WHERE clauses - are applied when you use /project
  • the project configuration does not include table and row selections for the comparison results
  • the command line cannot back up databases before synchronization

    If the project includes backup settings that have been set up using the Synchronization Wizard, those settings are ignored.

To synchronize data in WidgetDev and WidgetLive, specifying that for table WidgetPrices only columns RecordID, Price, and Active are to be migrated:

sqldatacompare /Database1:WidgetDev /Database2:WidgetLive
/IncludeColumns:WidgetPrices:RecordID,Price,Active
/Synchronize

Using a backup as a data source

To compare a backup of WidgetDev with WidgetLive:

sqldatacompare
/Backup1:D:\MSSQL\BACKUP\WidgetDev_20080807_143235.sqb
/db2:WidgetLive

If you are using native SQL Server backups and the backup files contain multiple backup sets, use the /Backupset1 and /Backupset2 switches to specify the required backup set. If the backup set switches are not specified, SQL Data Compare uses the latest backup set.

sqldatacompare /Backup1:D:\MSSQL\BACKUP\WidgetDev.bak
/Backupset1:"2008-09-23 Full Backup" /db2:WidgetLive

To specify more than one backup file, the file names are separated using semicolons.

sqldatacompare /Backup1:D:\MSSQL\BACKUP\WidgetDev_Full.bak
D:\MSSQL\BACKUP\WidgetDev_Diff.bak /db2:WidgetLive

For encrypted backups that have been created using SQL Backup, use the /Password1 and /Password2 switches to specify the passwords; when there is more than one password, the passwords are separated using semicolons.

sqldatacompare /Backup1:D:\MSSQL\BACKUP\WidgetDev.sqb
/Password1:Pa$$w0rd /db2:WidgetLive

Scheduling a comparison

You can use the Microsoft® Windows® Scheduled Task wizard to schedule a comparison by creating a script to run the comparison.

For example, to compare the data in two databases, you could create the following script:

C:
cd path_to_installation_folder
sqldatacompare /db1:FirstDatabaseName
/db2:SecondDatabaseName >> log_file

where:

  • path_to_installation_folder is the path to the folder in which you installed the tool. Alternatively, you can add the installation folder to your PATH environment variable and omit this line.
  • FirstDatabaseName and SecondDatabaseName are the names of the databases that you want to compare.
  • log_file is the full path to the log file. For example, C:\SQLCmdLine\Log.txt

In this example MS-DOS batch scripting is used, a basic scripting language that is supported on all versions of Windows. If preferred, you could use VBScript, JScript, PHP, Perl, Python or any other scripting language of your choice.

Save the script as a .bat file. You can then specify the .bat file as the program to run from within the Scheduled Task wizard by browsing to it.

See also

Exit codes used in the command line

Options used in the command line

Getting started with the SQL Data Compare command line

Deploying a database from source control


Example: selecting single tables for comparison

This example illustrates how you select a single table for comparison.

In this example, the databases contain the following tables (amongst others):

  • Product
  • ProductCategory
  • ProductCostHistory
  • ProductDealerPriceHistory
  • SpecialOfferProduct

You are interested only in the differences between the Product tables in two different versions of your database; you are not interested in any of the other tables or views in the databases.

Using the command line

To specify the table to include, you use the /Include switch:

sqldatacompare /db1:Products1 /db2:Products2
/Include:table:\[Product\] /verbose

where:

  • /db1:Products1

    specifies that you want to compare the database Products1

  • /db2:Products2

    specifies that you want to compare the database Products2

  • /Include:table:\[Product\]

    specifies that you want to compare only the table that has a name that includes the string [Product]

  • /verbose

    specifies that you want to display detailed information about differences between objects

Note that you use .NET standard regular expressions to define the /Include and /Exclude arguments. Therefore, you must escape the square brackets ( [ ] ) with the backslash character ( \ ). Regular expression syntax is beyond the scope of this online help; refer to your Microsoft .NET framework documentation for more information.

You must include the brackets ( [ ] ) in the string; if you specify the argument without the brackets, /Include:table:Product, the ProductCategory table is included because it contains the string Product. The full SQL Server table names are qualified by the owner name in SQL Server 2000, and the schema name in SQL Server 2005/2008, and include brackets. For example (in SQL Server 2000):

[dbo].[Product]

[dbo].[ProductCategory]

and so on. Therefore, the brackets indicate that you are specifying the full table name. To include the owner (or schema) name in the regular expression, you would need also to escape the dot ( . ):

/Include:table:\[dbo\]\ .\[Product\]

The pipe character ( | ) in a regular expression is interpreted as a logical OR. The character must be escaped by the caret character ( ^ ), to prevent the operating system shell from interpreting it as the pipe operator. (Note that if you want to use the caret character itself as part of your regular expression, it must be escaped by a second caret.)

Using XML

You can use XML as follows:

<?xml version="1.0"?> <commandline>
<database1>Products1</database1>
<database2>Products2</database2>
<verbose/>
<include>Table:\[Product\]</include>
</commandline>

To execute the comparison using the XML file, enter the following command:

sqldatacomapre /Argfile:xmlfilename.xml

where xmlfilename is the name of the XML file.

See also

Getting started with the SQL Data Compare command line

Options used in the command line

Example: selecting tables with unrelated names

Exit codes used in the command line

Simple examples using the command line


Example: selecting tables with unrelated names

This example illustrates how you select a number of individual tables for comparison when their names are not related in any way.

In this example, the databases contain the following tables:

  • Product
  • Supplier
  • ProductCategory
  • SpecialOffer
  • Customer
  • Order
  • Invoice

You are interested only in the differences between the Product, Customer, Order, and Invoice tables in two different versions of your database, Customers1 and Customers2.

Using the command line

To specify the list of tables to include, you use the /Include switch. You could use an Include switch for each table that you want to compare. However, this could get unwieldy if you have a long list of tables. Instead, you can use the pipe character ( | ) to separate the table names:

sqldatacomapre /db1:Customers1 /db2:Customers2
/include:table:\[Product\]^|Customer^|Order^|Invoice

where:

  • /db1:Customers1

    specifies that you want to compare the database Customers1

  • /db2:Customers2

    specifies that you want to compare the database Customers2

  • /Include:table:\[Product\]^|Customer^|Order^|Invoice

    specifies that you want to compare only the tables that have a name that includes the strings [Product], or Customer, or Order, or Invoice

Note that you use .NET standard regular expressions to define the /Include and /Exclude arguments. Therefore, you must escape the square brackets ( [ ] ) with the backslash character ( \ ). Regular expression syntax is beyond the scope of this online help; refer to your Microsoft .NET framework documentation for more information.

You must include the brackets ( [ ] ) in the string; if you specify the argument without the brackets, /Include:table:Product, the ProductCategory table is included because it contains the string Product. The full SQL Server table names are qualified by the owner name in SQL Server 2000, and the schema name in SQL Server 2005/2008, and include brackets. For example (in SQL Server 2000):

[dbo].[Product]

[dbo].[ProductCategory]

and so on. Therefore, the brackets indicate that you are specifying the full table name. To include the owner (or schema) name in the regular expression, you would need also to escape the dot ( . ):

/Include:table:\[dbo\]\ .\[Product\]

The pipe character ( | ) in a regular expression is interpreted as a logical OR. The character must be escaped by the caret character ( ^ ), to prevent the operating system shell from interpreting it as the pipe operator. (Note that if you want to use the caret character itself as part of your regular expression, it must be escaped by a second caret.)

Using XML

You can use XML as follows:

<?xml version="1.0"?> <commandline>
<database1>Customers1</database1>
<database2>Customers2</database2>
<sync/>
<include>Table:\[Product\]|Customer|Order|Invoice</include>
</commandline>

Note that the pipe character ( | ) (and other operating system operators) do not have to be escaped by the caret character ( ^ ) when they are specified in the XML file, but ( < ) and ( > ) must be escaped.

To execute the comparison using the XML file, enter the following command:

sqldatacomapre /Argfile:XMLFileName.xml

where XMLfilename is the name of the XML file.

See also

Simple examples using the command line

Exit codes used in the command line

Example: selecting single tables for comparison

Options used in the command line

Getting started with the SQL Data Compare command line


Using XML to specify command line arguments

You can use an XML file to specify the arguments for the command line interface. You may want to do this because:

  • An XML file is easier to read than a long and complex command line, particularly where complex rules for including and excluding objects are specified.
  • You can easily transform an XML file into other formats using XSLT.

    For example, you could transform your argument file to HTML for presentation on a Web page.

  • Using an XML file overcomes some limitations that can be a problem when you want to specify regular expressions as command line arguments.

    For example, you may want to use the pipe character ( | ) as part of a regular expression, but it causes problems when it is used at the command prompt; if you use an XML file you can use the pipe character with no problems.

  • Most programming languages support XML, through built-in or freely available third-party libraries.

    This makes it easy to generate and process the XML file.

Create the XML file in the following format:

<?xml version="1.0"?> <commandline> <switch_name1/>
<switch_name2>switch_value</switch_name2>
.... </commandline>

For example, for the /include and /exclude switches, use the following format:

<include>objecttype:RegularExpression</include>

To execute the command line tools using an XML argument file as input, at the command prompt enter:

sqldatacompare /Argfile:XMLfilename.xml

When using an XML file note that:

  • you cannot specify any other switches on the command line except /verbose or /quiet
  • multiple options should be separated with commas:

<options>n,oc,t</options>

Examples

Below are some examples of XML files that can be used with the SQLDataCompare tool. The command line versions of the examples (using aliases) are also provided for comparison. To migrate changes in the XML examples, use the <synchronize/> element.

To compare the data in all tables in two local databases (Windows authentication):

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName

To compare the data in all tables in databases on different hosts:

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<server1>Hostname1</server1>
<database2>SecondDatabaseName</database2>
<server2>Hostname2</server2>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /s1:Hostname1 /s2:Hostname2

To compare the data in all tables in two databases using SQL Server authentication:

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<username1>Username1</username1>
<password1>Password1</password1>
<database2>SecondDatabaseName</database2>
<username2>Username2</username2>
<password2>Password2</password2>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /u1:Username1
     /p1:Password1 /db2:SecondDatabaseName /u2:Username2
     /p2:Password2

To compare the data only in tables whose name contains the word Product:

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
<include>Table:Product</include>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /include:table:\[Product\]

To compare the data only in tables whose name contains the word Product, except for the ProductHistory table:

Using an XML file:

<?xml version="1.0"?>
<commandline> <database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
<include>Table:Product</include>
<exclude>Table:ProductHistory</exclude>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /include:table:\[Product\] /exclude:table:\[ProductHistory\]

To compare the data in tables using an index as a comparison key

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
<comparisonkeys>TableName:IndexName</comparisonkeys>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /comparisonkeys:TableName:IndexName

To compare a backup file with a database:

Using an XML file:

<?xml version="1.0"?> <commandline>
<backup1>D:\MSSQL\BACKUP\BackupOfFirstDatabase.sqb</backup1>
<database2>SecondDatabaseName</database2>
</commandline>

Using the command line:

sqldatacompare /backup1:D:\MSSQL\BACKUP\BackupOfFirstDatabase.sqb
     /db2:SecondDatabaseName

To retrieve verbose output of the data differences between two databases:

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
<verbose/>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /verbose

To migrate data changes from the first database to the second database:

Using an XML file:

<?xml version="1.0"?> <commandline>
<database1>FirstDatabaseName</database1>
<database2>SecondDatabaseName</database2>
<synchronize/>
</commandline>

Using the command line:

sqldatacomapre /db1:FirstDatabaseName /db2:SecondDatabaseName
     /synchronize

See also

Simple examples using the command line

Example: selecting single tables for comparison

Example: selecting tables with unrelated names

Deploying a database from source control

Options used in the command line

Exit codes used in the command line


Deploying a database from source control

This topic provides a simple example of using the SQL Compare and SQL Data Compare command line interfaces to deploy a database from source control.

In this example, changes have been made to the schema and data of the database WidgetDev. These changes must be deployed to the testing database WidgetTest.

The latest version of WidgetDev is maintained in source control as the scripts folder WidgetScripts.

The changes are deployed by using SQL Compare and then SQL Data Compare to synchronize WidgetTest (the target) with WidgetScripts (the source).

For more information, see

  • Working with scripts folders
  • Continuous integration for databases using Red Gate SQL tools (pdf)

Before we can deploy, we must get the latest version of WidgetScripts from source control. In this example, the latest version is updated to the working folder C:\Scripts\WidgetScripts

We will deploy all changes to the database schema, and changes to only the static data. The transactional data in the table WidgetPurchases will not be modified.

Note that:

  • Scripts folders and the command line interface are only available with the SQL Compare and SQL Data Compare Professional Editions.
  • Schema synchronization must therefore be performed first, as data synchronization may fail if the schemas are not identical.

Deploying the schema

To deploy the schema and save a basic report of the process, at the command prompt type:

sqlcompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/sync /v > "C:\SchemaDeploy.txt"

To create a more readable report of the schema differences and save a copy of the synchronization script used to deploy the changes type:

sqlcompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/Report:"C:\SchemaDiffReport.html"

/ReportType:Interactive

/ScriptFile:"C:\SchemaSyncScript.sql"

/sync

Where:

  • /scr1:"C:\Scripts\WidgetScripts" specifies WidgetScripts as the source
  • /db2:WidgetTest specifies WidgetTest as the target
  • /o:Default specifies that the default SQL Compare options will be used for comparison and synchronization
  • /sync synchronizes the data sources, making WidgetTest the same as WidgetScripts
  • /v > "C:\SchemaDeploy.txt" directs detailed command line output to a file
  • /Report generates a report of the schema differences and writes it to the specified file
  • /ReportType specifies the format of the report
  • /ScriptFile saves a copy of the SQL script used to migrate the changes

Deploying the data

To deploy the data and create a basic report, at the command prompt type:

/sqldatacompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/Exclude:table:WidgetPurchases

/sync /v > C:\DataDeploy.txt

To save a copy of the synchronization script used to deploy the changes type:

sqldatacompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/Exclude:table:WidgetPurchases

/ScriptFile:"C:\DataSyncScript.sql"

/sync /v > C:\DataDeploy.txt

Where:

  • /scr1:"C:\Scripts\WidgetScripts" specifies WidgetScripts as the source
  • /db2:WidgetTest specifies WidgetTest as the target
  • /o:Default specifies that the default SQL Data Compare options will be used for comparison and synchronization
  • /sync synchronizes the data sources, making WidgetTest the same as WidgetScripts
  • /v > "C:\DataDeploy.txt" directs detailed command line output to a file
  • /exclude:table:WidgetPurchases excludes WidgetPurchases. All other tables will be deployed.
  • /ScriptFile saves a copy of the SQL script used to migrate the changes

Automating the process

To automate the deployment, save the command line as a .bat file:

cd "C:\Program Files\Red Gate\SQL Compare 8"

sqlcompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/Report:"C:\SchemaDiffReport.html"

/ReportType:Interactive

/ScriptFile:"C:\SchemaSyncScript.sql"

/sync

cd "C:\Program Files\Red Gate\SQL Data Compare 8"

sqldatacompare /scr1:"C:\Scripts\WidgetScripts" /db2:WidgetTest

/o:Default

/Exclude:table:WidgetPurchases

/ScriptFile:"C:\DataSyncScript.sql"

/sync /v > C:\DataDeploy.txt

You can then schedule deployment using the Microsoft® Windows® Scheduled Task wizard.

Additionally, you can automatically update the scripts in source control with the changes from the development database by using the development database as the source for the synchronization (/db1:WidgetDev) and a scripts folder as the target (/scr2:WidgetScripts).

See also

Keeping a database in source control

Working with scripts folders

Switches used in the command line

Options used in the command line

Simple examples using the command line


Command line syntax

In this chapter

  • Switches used in the command line
  • Options used in the command line
  • Exit codes used in the command line


Switches used in the command line

This topic provides a list of the switches you can use with the SQL Data Compare command line.

Note that:

  • the first data source ( /db1, /b1, and so on ) is the source
  • the second data source ( /db2, /b2, and so on ) is the target
  • there are changes to the command line syntax of SQL Data Compare in version 8

    The names, aliases, and behaviour of some switches and options is different to that of earlier versions.

    For more information, see Changes to the command line in SQL Data Compare 8

/AllowIdenticalDatabases

This switch is deprecated. Instead use /Include:Identical

/Include:Identical suppresses the exit code if the two data sources are identical. If /Include:Identical is not set, SQL Data Compare returns the error code 63.

/Argfile:<argfile>

Runs a file containing an XML argument specification:

sqldatacompare /Argfile:XMLFileName.xml

For more information see Using XML to specify command line arguments

/Backup1:<filename1>;<filename2>;...;<filenameN>

Alias: /b1

Specifies the backup to be used as the first data source (the source). You must add all of the files making up the backup set you want to compare:

sqldatacompare /Backup1:D:\BACKUPS\WidgetStaging.bak /db2:WidgetStaging

To specify more than one backup file, the file names are separated using semicolons:

sqldatacompare /Backup1:D:\BACKUPS\WidgetDev_Full.bak;
     D:\BACKUPS\WidgetDev_Diff.bak /db2:WidgetDev

/Backup2:<filename1>;<filename2>;...;<filenameN>

Alias: /b2

Specifies the backup to be used as the second data source (the target). You must add all of the files making up the backup set you want to compare:

sqldatacompare /db1:WidgetStaging /Backup2:D:\BACKUPS\WidgetStaging.bak

/BackupPasswords1:<Password1>,<Password2>,...,<Password1N>

Alias: /bpsw1

Specifies the password for the first backup:

sqldatacompare /Backup1:D:\BACKUPS\WidgetStaging.bak
/BackupPasswords1:P@ssw0rd /db2:WidgetProduction

/BackupPasswords2:<Password1>,<Password2>,...,<Password1N>

Alias: /bpsw2

Specifies the password for the second backup:

sqldatacompare /db1:WidgetStaging
/Backup2:D:\BACKUPS\WidgetProduction.bak /BackupPassword2:P@ssw0rd

/BackupSet1:<backupset>

Alias: /bks1

If you are comparing a backup set that contains multiple files, use the /BackupSet1 switch to specify the files which make up the first backup set, and use the /backupset2 switches to specify the files which make up the second:

sqldatacompare /Backup1:"D:\MSSQL\BACKUP\WidgetDev.bak"
/BackupSet1:"2008-09-23 Full Backup" /db2:WidgetLive

If the backup set switches are not specified, SQL Data Compare uses the latest backup set.

To specify more than one backup file, the file names are separated using semicolons.

sqldatacompare /Backup1:D:\BACKUPS\WidgetDev_Full.bak;
"D:\BACKUPS\WidgetDev_Diff.bak" /db2:WidgetDevlopment

For encrypted backups that have been created using SQL Backup, use the /BackupPasswords1 and /BackupPasswords2 switches to specify the passwords; when there is more than one password, the passwords are separated using semicolons.

sqldatacompare /Backup1:D:\BACKUPS\WidgetDev.sqb /BackupPassword1:Pa$$w0rd
/db2:WidgetLive

/BackupSet2:<backupset>

Alias: /bks2

Specifies which backup set to use for the second backup:

sqldatacompare /db1:WidgetProduction /BackupSet2:"2008-09-23 Full Backup"

/CaseSensitive

This switch is deprecated. Instead use /Options:CaseSensitiveObjectDefinition

/Columns

This switch is deprecated. Instead use /IncludeColumns and /ExcludeColumns

/ComparisonKeys:<table or view name as regular expression>:<index name>

Alias: /ck

Specifies a unique index to be used to identify rows for comparison.

The name of the table or view is specified using a regular expression - you do not have to specify fully-qualified names. It is recommended that you use a regular expression which matches only one table or view:

sqldatacompare /Database1:WidgetStaging /Database2:WidgetProduction
/IncludeColumns:\[WidgetPrices\]:Price
/ComparisonKeys:\[WidgetPrices\]:PK_WidgetPrices

Note that:

  • /ComparisonKeys must be used with the /IncludeColumns switch
  • with /ComparisonKeys you can only specify an index as the comparison key, no other columns can be specified

To specify a comparison key that is is not an index, use the GUI to set up and save a project with the settings you require. You can then use that project from the command line with the /Project switch.

For more information on using the GUI to set comparison keys, see Selecting the comparison key, under Selecting tables and views.

/Database1:<database1>

Alias: /db1

Specifies a database to use as the source:

sqldatacompare /Database1:WidgetStaging /Database2:WidgetProduction

/Database2:<database2>

Alias: /db1

Specifies a database to use as the source:

sqldatacompare /database1:WidgetStaging /database2:WidgetProduction

/Exclude:<object type>:<regular expression>

Arguments:

  • Additional

includes only those objects that are not present in the source (eg /db1)
  • Missing

includes only those objects that are not present in the target (eg /db2)
  • Different

includes only those objects that are present in both data sources, but are different.
  • Identical

Includes identical objects in the command line output and any generated reports.
  • User specified

includes the specific objects you specify with a regular expression

To specify the list of objects to exclude, use the /exclude switch:

sqldatacompare /db1:Customers1 /db2:Customers2 /Exclude:table

/Exclude:table specifies that you do not want to compare tables; you only want to compare other objects such as views, stored procedures, and so on.

To specify more than one object, or object type type for exclusion use multiple /Exclude switches. For example, to exclude only tables and views:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/Exclude:table:WidgetReferences /Exclude:view

Note that you cannot use /exclude with the /include and /project switches.

For a more detailed example of how to use the /include and /exclude switches, see Example: selecting tables with unrelated names.

/ExcludeColumns:<table or view name>:<regular expression>

Alias: /ec

Specifies which columns within a table or view are excluded from synchronization.

Table or view names are matched using a regular expression so that you do not have to specify fully qualified names. However, it does not usually make sense to supply a regular expression that matches more than one table or view. Multiple column names should be specified as a comma-delimited list.

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/ExcludeColumns:WidgetReferences:WidgetName

Note that /ExcludeColumns takes precedence over /IncludeColumns

/Export:<directory>

Alias: /e

Exports the comparison results to the specified directory as a .csv file.

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/Export:C:\WidgetResults

Note that the file created is always called Summary.csv

You specify the directory in which the file is created.

/ExportIdenticalTables

This switch is deprecated. Instead use /Include:Identical

/Force

Alias: /f

This forces the overwriting of any output files that already exist. If this switch is not used and a file of the same name already exists, the program will exit with the exit code indicating an IO error.

/IgnoreParserErrors

If SQL Data Compare encounters any high level errors when parsing a scripts folder, it will exit with an error code of 62.

Use /ignoreParserErrors to force SQL Data Compare to continue without exiting.

/Include:<object type>:<regular expression>

Arguments:

  • Additional

includes only those objects that are not present in the source (eg /db1)
  • Missing

includes only those objects that are not present in the target (eg /db2)
  • Different

includes only those objects that are present in both data sources, but are different.
  • Identical

Includes identical objects in the command line output and any generated reports.
  • User specified

includes the specific objects you specify with a regular expression

This switch is used to specify the list of objects to include. You could use an /Include switch for each object that you want to compare. However, this could get unwieldy if there is a long list. Instead, you can use the pipe character ( | ) to separate the table names:

sqldatacompare /db1:Customers1 /db2:Customers2 /Include:table
/Include:table:\[Product\]^|Customer^|Order^|Invoice

/Include:Identical suppresses the exit code if the two data sources are identical. If /Include:Identical is not set, SQL Data Compare returns the error code 63.

For a more detailed example of how to use the /include switch, see: Example: selecting tables with unrelated names

/IncludeAdditional

This switch is deprecated. Instead use /Include:Additional

/IncludeColumns

Alias: /ic

Specifies which columns within a table or view are included in the synchronization.

Table or view names are matched using a regular expression so that you do not have to specify fully qualified names. However, it does not usually make sense to supply a regular expression that matches more than one table or view. Multiple column names should be specified as a comma-delimited list.

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/IncludeColumns:WidgetReferences:WidgetName

Note that /ExcludeColumns takes precedence over /IncludeColumns

/MakeScripts:<folder>

Alias: /mkscr

Creates a scripts folder from the first (source) data source.

sqldatacompare /db1:WidgetStaging
/MakeScripts:"C:\Scripts Folders\Widget staging scripts"

If the folder already exists an error will occur. To merge scripts into an existing scripts folder, compare them with that folder and use the /synchronize switch:

sqldatacompare /scr1:"C:\Scripts Folders\Widget dev scripts"
/scr2:"C:\Scripts Folders\Widget staging scripts" /Synchronize

/options:<option1>,<option2>,<option3>

Alias: /o

Applies the project configuration options used during comparison or synchronization:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/Options:Default,IgnoreWhiteSpace

For a detailed list of these options, see Options used in the command line.

/Out:<FileName>

Redirects console output to the specified file:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction /Out:C:\output file

/OutputProject:<FileName>

Alias: /outpr

Writes the settings used for the comparison to the specified SQL Data Compare project file:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/Options:Default,IgnoreWhiteSpace /OutputProject:"C:\WidgetProject.scp"

This also generates a SQL Data Compare project file. These files end with a .scp extension. If the file already exists an error will occur, unless you have also used the /force switch.

/OutputWidth:<columns>

Forces the width of console output.

This can be used to ensure that database object names etc are not truncated, and that SQL script lines are not wrapped or broken. This is particularly useful when redirecting output to a file as it allows you to overcome the limitations of the default console width of 80 characters.

/Password1:<password1>

Alias: /p1

The password for the first database (source).

You must also provide a username. If you do not specify a username and password combination, integrated security is used:

sqldatacompare /db1:WidgetStaging /UserName1:User1 /Password1:P@ssw0rd
/db2:WidgetProduction /UserName2:User2 /Password2:Pa$$w0rd

Note that this switch is only used if the source is a database. If the source is a backup, use /BackupPasswords1

/Password2:<password2>

Alias: /p2

The password for the second database.

/Project

Alias: /pr

Uses a SQL Data Compare project (.scp) file for the comparison.

To use a project you have saved as "widgets.scp" from the command line:

sqldatacompare /project:"C:\SQLCompare\Projects\Widgets.scp"

Note that:

  • When you use a project, all objects that were selected for comparison when you saved the project are automatically included.
  • When you use the command line, your project option selections are ignored and the defaults are used. Use /options to specify any additional options you want to use with a command line project.

    For more information, see Options used in the command line

  • If you want to include or exclude objects from an existing project, you must modify your selection using the graphical user interface.

You cannot use the /include and /exclude switches with /project.

/SyncScriptEncoding

Alias: /senc

Arguments:

  • UTF8

UTF-8 encoding, without preamble
  • UTF8WithPreamble

UTF-8 encoding, with 3-byte preamble
  • Unicode

UTF-16 encoding
  • ASCII

ASCII encoding

Specifies the character encoding used when writing the SQL script file. The default is UTF8.

For example:

sqldatacompare /db1:WidgetStaging /MakeScripts: D:\Scripts Folder
/SyncScriptEncoding:ASCII

/ScriptFile:<scriptfile>

Alias: /sf

Generates a SQL script to migrate the changes which can be executed at a later time. If the file already exists an error will occur, unless you use the /force switch:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/ScriptFile: "C:\Scripts Folder\WidgetSyncScript.sql"

/scriptfile can be used when the target ( /db2, /scr2, /sn2 ) is a database, a snapshot, or a scripts folder.

If the target is a snapshot or a scripts folder, the generated script modifies a database with the schema represented by that snapshot or scripts folder.

/Scripts1:<folder>

Alias: /scr1

Specifies the script folder to use as the first data source:

sqldatacompare /Scripts1:"C:\Scripts Folder\WidgetStagingScript"
/db2:WidgetProduction

/Scripts2:<folder>

Alias: /scr2

Specifies the script folder to use as the second data source.

/Server1:<server1>

Alias: /s1

This specifies the server on which the first (/db1:) data source is located. If an explicit path is not specified, it defaults to Local.

sqldatacompare /Server1:Widget_Server\SQL2008 /db1:WidgetStaging
/db2:WidgetProduction

/Server2:<server2>

Alias: /s2

This specifies the server on which the second (/db2:) data source is located. If an explicit path is not specified, it defaults to Local.

/Synchronize

Alias: /sync

Synchronizes the databases after comparison.

The target (for example, /db2) is modified; the source (for example, /db2) is not modified:

sqldatacompare /db1:WidgetStaging /db2:WidgetProduction
/Synchronize

/UserName1:<username1>

Alias: /u1

The username for the first database.

If no username is specified, integrated security is used.

sqldatacompare /db1:WidgetStaging /UserName1:User1 /Password1:P@ssw0rd
/db2:WidgetProduction /UserName2:User2 /Password2:Pa$$w0rd

/UserName2:<username2>

Alias: /u2

The username for the second database.

If no username is specified, integrated security is used.

See also

Options used in the command line

Exit codes used in the command line

Using XML to specify command line arguments

Integrating the command line with applications

Simple examples using the command line


Options used in the command line

You can set project configuration options by using the /Options switch.

For example, when mapping objects, SQL Data Compare considers underscores in object names to be differences by default. Therefore, if the objects [dbo].[Widget_Prices] and [dbo].[WidgetPrices] were identical, they would not be mapped, and so could not be compared. To successfully compare these objects, use:

     /Options:IgnoreUnderscores

SQL Data Compare now treats those objects as identical, and they can be compared.

To specify multiple options, separate the options using commas:

     /Options:<option1>,<option2>,<option3>

If you do not explicitly set any options, the defaults are used. See Defaults below.

Note that there are changes to the command line syntax of SQL Data Compare in version 8. The names, aliases, and behaviour of some switches and options is different to that of earlier versions.

For more information, see Changes to the command line in SQL Data Compare 8

Defaults

If you do not specify any options, the following default options apply:

  • IgnoreSpaces
  • IncludeTimestamps
  • IncludeIndexedViews
  • IncludeIdentities
  • DisableKeys
  • UseTransactions
  • OutputComments
  • (IgnoreCase) - This option is deprecated, and case insensitive comparison is now the default behaviour.

If you want to use these defaults with additional options, specify the default argument and the additional options. For example:

     /Options:Default,TrimTrailingSpaces,CompressTemporaryFiles

If you do not specify the default argument, only the options you explicitly specify apply.

To specify no options, use the none argument.

Further options are detailed below.

CaseSensitiveObjectDefinition

Alias: cs

Treats object definitions as case sensitive when mapping. For example, Table_A and table_a would not be mapped automatically.

CompressTemporaryFiles

Alias: ctf

Compresses the temporary files that SQL Data Compare generates while performing the comparison. This makes it less likely that you will run out of disk space when comparing very large databases.

Default

Alias: d

Applies the default options.

DisableAndReenableDDLTriggers

Alias: drd

DDL triggers can cause problems when you run the synchronization. Select this option to disable any enabled DDL triggers before synchronizing the databases, and re-enable those triggers following synchronization.

DisableAndReenableDMLTriggers

Alias: t

Disables DML triggers on tables and views before synchronizing the databases, and then re-enables those triggers following synchronization.

DisableKeys

Alias: k

Disables foreign keys before synchronizing the databases, and then re-enables those foreign keys following synchronization. Note that in some circumstances foreign keys will be dropped and re-created rather than disabled and re-enabled.

DoNotOutputCommentHeader

Alias: nc

When this option is selected, comment headers are not included in the output script.

DropConstraintsAndIndexes

Alias: c

Drops primary keys, indexes, and unique constraints before synchronizing the databases, then re-creates them following the synchronization.

If the primary key, index, or unique constraint is the comparison key, it cannot be dropped.

ForceBinaryCollation

Alias: fbc

Forces binary collation for all string data types, irrespective of column collation, resulting in a case-sensitive comparison. When this option is selected and the comparison key is a string, this may result in slower performance because the indexes are not used.

ForceCheck

New option. Forces any constraints (for example, those on foreign keys) disabled by SQL Data Compare to be re-enabled with CHECK.

IgnoreCase

This option is deprecated, and case insensitive comparison is now the default behaviour.

IgnoreSpaces

Alias: is

When mapping objects for comparison, spaces in the names of objects are considered by default. This option ignores spaces in the names of objects, enabling them to be mapped. For example [dbo].[Widget Prices] is mapped to [dbo].[WidgetPrices].

IgnoreUnderscores

Alias: iun

When mapping objects for comparison, underscores in the names of objects are considered by default. This option ignores underscores in the names of objects, enabling them to be mapped. For example, [dbo].[Widget_Prices] is mapped to [dbo].[WidgetPrices].

IncludeIdentities

Alias: iid

Includes identity columns in the comparison.

Note that you cannot synchronize a view if it includes an identity column.

IncludeIndexedViews

Alias: v

Includes views in the comparison. Views can be synchronized only if the referenced rows are from a single table, and the referenced columns are simple. For example, they must not include identity columns or computed columns.

IncludeTimestamps

Alias: its

Includes timestamp columns in the comparison.

Note that timestamp columns cannot be synchronized.

None

Alias: n

To specify no options, use the none argument.

OutputComments

Alias: oc

Includes comments in the synchronization SQL script.

ReSeedIdentity

Alias: rsi

Re-seeds identity columns so that identity values in the database you are updating match values in the source database.

TransportCLRBinary

Alias: tclr

When this option is selected, SQL Data Compare uses the binary representation of CLR types in the synchronization SQL script. If this option is not selected, CLR data types are represented as strings.

TrimTrailingSpaces

Alias: tts

When this option is selected, and the data in two columns differs only by the number of spaces at the end of the string, SQL Data Compare treats those columns as identical.

Note that this option does not apply to CLR columns, or XML columns.

UseChecksumComparison

Alias: ucc

When this option is selected, SQL Data Compare performs a checksum prior to comparison. Data is compared only if the checksums differ. You can use this option to improve the performance of SQL Data Compare.

Note that in SQL Server 2000 databases, db_owner permissions are required to use this option.

UseTransactions

Alias: ut

When this option is selected transactions are used in the synchronization SQL scripts, enabling changes to be rolled back if the synchronization fails. BEGIN TRANSACTION is inserted at the beginning of the synchronization SQL script, and COMMIT TRANSACTION at the end of the script.

See also

Switches used in the command line

Exit codes used in the command line

Using XML to specify command line arguments

Simple examples using the command line


Exit codes used in the command line

If a task you are performing with the SQL Data Compare command line interface fails, and you do not see an error message explaining the reason for the failure, you may see one of the exit codes detailed below:

3 - Illegal argument duplication

Some arguments cannot be used more than once in a command line.

8 - Unsatisfied argument dependency

There is an unsatisfied argument dependency or violated exclusion when the command line is run. For example:

  • /arg2 depends on /arg1 but you have specified /arg2 without specifying /arg1
  • /arg2 cannot be used with /arg1 but you have used both

32 - Value out of range

The numeric value supplied for an argument is outside the range of valid values for that argument.

33 - Value overflow

The value supplied for an argument is too large.

34 - Invalid value

The value supplied for an argument is invalid.

35 - Invalid license

Software license or trial period has expired.

62 - High level parser error

SQL Data Compare encountered high level errors when parsing a scripts folder.

Use /ignoreParserErrors to force SQL Data Compare to continue without exiting.

63 - Databases identical

The databases being compared are identical or no objects have been included.

65 - Data error

Data required by SQL Data Compare is invalid or corrupt.

This often indicates that a constraint violation occurred while running the synchronization script. Check your schema to ensure that when you are migrating data you do not violate any constraints in the schema. You should either modify the data you are migrating, or change the SQL Data Compare command line options to resolve the problem.

69 - Resource unavailable

A resource or service required to run SQL Data Compare is unavailable.

73 - Failed to create report

The report was not created.

74 - I/O error

For example, this is returned if SQL Data Compare attempts to write to a file that already exists, and the /force switch has not been set.

77 - Insufficient Permission

The action cannot be completed because the user does not have the necessary permission.

See also

Switches used in the command line

Options used in the command line

Using XML to specify command line arguments

Integrating the command line with applications

Simple examples using the command line


Acknowledgements

Trademarks and registered trademarks

Red Gate is a registered trademark of Red Gate Software Ltd registered in the U.S. Patent and Trademark Office.

SQL Compare is a registered trademark of Red Gate Software Ltd registered in the U.S. Patent and Trademark Office.

ANTS Profiler, Exception Hunter, SQL Backup, SQL Data Compare, SQL Comparison SDK, SQL Dependency Tracker, SQL Doc, SQL Log Rescue, SQL Multi Script, SQL Packager, SQL Prompt, SQL Refactor, SQL Response, and SQL Toolbelt are trademarks of Red Gate Software Ltd.

Microsoft, Windows, Windows 98, Windows NT, Windows 2000, Windows 2003, Windows XP, Windows Vista, Visual Studio, and other Microsoft products referenced herein are either registered trademarks or trademarks of Microsoft Corporation.

InstallShield is a registered trademark and service mark of InstallShield Software Corporation.

Copyright information

All Red Gate applications are © Red Gate Software Ltd 1999 - 2009

SQL Backup, SQL Compare, SQL Data Compare, SQL Packager, and SQL Prompt contain software that is Copyright © 1995 - 2005 Jean-loup Gailly and Mark Adler.

SQL Doc includes software developed by Aspose (http://www.Aspose.com).

SQL Backup contains software that is Copyright © 2003 - 2008 Terence Parr. Refer to the ACKNOWLEDGEMENTS.txt file in your SQL Backup installation directory for the full license text.